module basis
  implicit none

contains
  function emsav(x,c) result(v)
    implicit none
    real,dimension(1:3)::x
    real,dimension(0:945)::c
    real::v
    ! ::::::::::::::::::::
    real,dimension(0:945)::p

    call bemsav(x,p)
    v = dot_product(p,c)

    return
  end function emsav

  subroutine bemsav(x,p)
    implicit none
    real,dimension(1:3),intent(in)::x
    real,dimension(0:945),intent(out)::p
    ! ::::::::::::::::::::
    real,dimension(0:4)::m

    call evmono(x,m)
    call evpoly(m,p)

    return
  end subroutine bemsav

  subroutine evmono(x,m)
    implicit none
    real,dimension(1:3),intent(in)::x
    real,dimension(0:4),intent(out)::m
    !::::::::::::::::::::

    m(0) = 1.0D0
    m(1) = x(3)
    m(2) = x(2)
    m(3) = x(1)
    m(4) = m(2)*m(3)

    return
  end subroutine evmono

  subroutine evpoly(m,p)
    implicit none
    real,dimension(0:4),intent(in)::m
    real,dimension(0:945),intent(out)::p
    !::::::::::::::::::::

    p(0) = m(0)
    p(1) = m(1)
    p(2) = m(2) + m(3)
    p(3) = p(1)*p(2)
    p(4) = m(4)
    p(5) = p(1)*p(1)
    p(6) = p(2)*p(2) - p(4) - p(4)
    p(7) = p(1)*p(4)
    p(8) = p(1)*p(3)
    p(9) = p(1)*p(6)
    p(10) = p(4)*p(2)
    p(11) = p(1)*p(5)
    p(12) = p(2)*p(6) - p(10)
    p(13) = p(1)*p(7)
    p(14) = p(1)*p(10)
    p(15) = p(1)*p(8)
    p(16) = p(1)*p(9)
    p(17) = p(4)*p(4)
    p(18) = p(1)*p(12)
    p(19) = p(4)*p(6)
    p(20) = p(1)*p(11)
    p(21) = p(2)*p(12) - p(19)
    p(22) = p(1)*p(13)
    p(23) = p(1)*p(14)
    p(24) = p(1)*p(17)
    p(25) = p(1)*p(19)
    p(26) = p(1)*p(15)
    p(27) = p(1)*p(16)
    p(28) = p(1)*p(18)
    p(29) = p(4)*p(10)
    p(30) = p(1)*p(21)
    p(31) = p(4)*p(12)
    p(32) = p(1)*p(20)
    p(33) = p(2)*p(21) - p(31)
    p(34) = p(1)*p(22)
    p(35) = p(1)*p(23)
    p(36) = p(1)*p(24)
    p(37) = p(1)*p(25)
    p(38) = p(1)*p(29)
    p(39) = p(1)*p(31)
    p(40) = p(1)*p(26)
    p(41) = p(1)*p(27)
    p(42) = p(1)*p(28)
    p(43) = p(4)*p(17)
    p(44) = p(1)*p(30)
    p(45) = p(4)*p(19)
    p(46) = p(1)*p(33)
    p(47) = p(4)*p(21)
    p(48) = p(1)*p(32)
    p(49) = p(2)*p(33) - p(47)
    p(50) = p(1)*p(34)
    p(51) = p(1)*p(35)
    p(52) = p(1)*p(36)
    p(53) = p(1)*p(37)
    p(54) = p(1)*p(38)
    p(55) = p(1)*p(43)
    p(56) = p(1)*p(39)
    p(57) = p(1)*p(45)
    p(58) = p(1)*p(47)
    p(59) = p(1)*p(40)
    p(60) = p(1)*p(41)
    p(61) = p(1)*p(42)
    p(62) = p(1)*p(44)
    p(63) = p(4)*p(29)
    p(64) = p(1)*p(46)
    p(65) = p(4)*p(31)
    p(66) = p(1)*p(49)
    p(67) = p(4)*p(33)
    p(68) = p(1)*p(48)
    p(69) = p(2)*p(49) - p(67)
    p(70) = p(1)*p(50)
    p(71) = p(1)*p(51)
    p(72) = p(1)*p(52)
    p(73) = p(1)*p(53)
    p(74) = p(1)*p(54)
    p(75) = p(1)*p(55)
    p(76) = p(1)*p(56)
    p(77) = p(1)*p(57)
    p(78) = p(1)*p(63)
    p(79) = p(1)*p(58)
    p(80) = p(1)*p(65)
    p(81) = p(1)*p(67)
    p(82) = p(1)*p(59)
    p(83) = p(1)*p(60)
    p(84) = p(1)*p(61)
    p(85) = p(1)*p(62)
    p(86) = p(4)*p(43)
    p(87) = p(1)*p(64)
    p(88) = p(4)*p(45)
    p(89) = p(1)*p(66)
    p(90) = p(4)*p(47)
    p(91) = p(1)*p(69)
    p(92) = p(4)*p(49)
    p(93) = p(1)*p(68)
    p(94) = p(2)*p(69) - p(92)
    p(95) = p(1)*p(70)
    p(96) = p(1)*p(71)
    p(97) = p(1)*p(72)
    p(98) = p(1)*p(73)
    p(99) = p(1)*p(74)
    p(100) = p(1)*p(75)
    p(101) = p(1)*p(76)
    p(102) = p(1)*p(77)
    p(103) = p(1)*p(78)
    p(104) = p(1)*p(86)
    p(105) = p(1)*p(79)
    p(106) = p(1)*p(80)
    p(107) = p(1)*p(88)
    p(108) = p(1)*p(81)
    p(109) = p(1)*p(90)
    p(110) = p(1)*p(92)
    p(111) = p(1)*p(82)
    p(112) = p(1)*p(83)
    p(113) = p(1)*p(84)
    p(114) = p(1)*p(85)
    p(115) = p(1)*p(87)
    p(116) = p(4)*p(63)
    p(117) = p(1)*p(89)
    p(118) = p(4)*p(65)
    p(119) = p(1)*p(91)
    p(120) = p(4)*p(67)
    p(121) = p(1)*p(94)
    p(122) = p(4)*p(69)
    p(123) = p(1)*p(93)
    p(124) = p(2)*p(94) - p(122)
    p(125) = p(1)*p(95)
    p(126) = p(1)*p(96)
    p(127) = p(1)*p(97)
    p(128) = p(1)*p(98)
    p(129) = p(1)*p(99)
    p(130) = p(1)*p(100)
    p(131) = p(1)*p(101)
    p(132) = p(1)*p(102)
    p(133) = p(1)*p(103)
    p(134) = p(1)*p(104)
    p(135) = p(1)*p(105)
    p(136) = p(1)*p(106)
    p(137) = p(1)*p(107)
    p(138) = p(1)*p(116)
    p(139) = p(1)*p(108)
    p(140) = p(1)*p(109)
    p(141) = p(1)*p(118)
    p(142) = p(1)*p(110)
    p(143) = p(1)*p(120)
    p(144) = p(1)*p(122)
    p(145) = p(1)*p(111)
    p(146) = p(1)*p(112)
    p(147) = p(1)*p(113)
    p(148) = p(1)*p(114)
    p(149) = p(1)*p(115)
    p(150) = p(4)*p(86)
    p(151) = p(1)*p(117)
    p(152) = p(4)*p(88)
    p(153) = p(1)*p(119)
    p(154) = p(4)*p(90)
    p(155) = p(1)*p(121)
    p(156) = p(4)*p(92)
    p(157) = p(1)*p(124)
    p(158) = p(4)*p(94)
    p(159) = p(1)*p(123)
    p(160) = p(2)*p(124) - p(158)
    p(161) = p(1)*p(125)
    p(162) = p(1)*p(126)
    p(163) = p(1)*p(127)
    p(164) = p(1)*p(128)
    p(165) = p(1)*p(129)
    p(166) = p(1)*p(130)
    p(167) = p(1)*p(131)
    p(168) = p(1)*p(132)
    p(169) = p(1)*p(133)
    p(170) = p(1)*p(134)
    p(171) = p(1)*p(135)
    p(172) = p(1)*p(136)
    p(173) = p(1)*p(137)
    p(174) = p(1)*p(138)
    p(175) = p(1)*p(150)
    p(176) = p(1)*p(139)
    p(177) = p(1)*p(140)
    p(178) = p(1)*p(141)
    p(179) = p(1)*p(152)
    p(180) = p(1)*p(142)
    p(181) = p(1)*p(143)
    p(182) = p(1)*p(154)
    p(183) = p(1)*p(144)
    p(184) = p(1)*p(156)
    p(185) = p(1)*p(158)
    p(186) = p(1)*p(145)
    p(187) = p(1)*p(146)
    p(188) = p(1)*p(147)
    p(189) = p(1)*p(148)
    p(190) = p(1)*p(149)
    p(191) = p(1)*p(151)
    p(192) = p(4)*p(116)
    p(193) = p(1)*p(153)
    p(194) = p(4)*p(118)
    p(195) = p(1)*p(155)
    p(196) = p(4)*p(120)
    p(197) = p(1)*p(157)
    p(198) = p(4)*p(122)
    p(199) = p(1)*p(160)
    p(200) = p(4)*p(124)
    p(201) = p(1)*p(159)
    p(202) = p(2)*p(160) - p(200)
    p(203) = p(1)*p(161)
    p(204) = p(1)*p(162)
    p(205) = p(1)*p(163)
    p(206) = p(1)*p(164)
    p(207) = p(1)*p(165)
    p(208) = p(1)*p(166)
    p(209) = p(1)*p(167)
    p(210) = p(1)*p(168)
    p(211) = p(1)*p(169)
    p(212) = p(1)*p(170)
    p(213) = p(1)*p(171)
    p(214) = p(1)*p(172)
    p(215) = p(1)*p(173)
    p(216) = p(1)*p(174)
    p(217) = p(1)*p(175)
    p(218) = p(1)*p(176)
    p(219) = p(1)*p(177)
    p(220) = p(1)*p(178)
    p(221) = p(1)*p(179)
    p(222) = p(1)*p(192)
    p(223) = p(1)*p(180)
    p(224) = p(1)*p(181)
    p(225) = p(1)*p(182)
    p(226) = p(1)*p(194)
    p(227) = p(1)*p(183)
    p(228) = p(1)*p(184)
    p(229) = p(1)*p(196)
    p(230) = p(1)*p(185)
    p(231) = p(1)*p(198)
    p(232) = p(1)*p(200)
    p(233) = p(1)*p(186)
    p(234) = p(1)*p(187)
    p(235) = p(1)*p(188)
    p(236) = p(1)*p(189)
    p(237) = p(1)*p(190)
    p(238) = p(1)*p(191)
    p(239) = p(4)*p(150)
    p(240) = p(1)*p(193)
    p(241) = p(4)*p(152)
    p(242) = p(1)*p(195)
    p(243) = p(4)*p(154)
    p(244) = p(1)*p(197)
    p(245) = p(4)*p(156)
    p(246) = p(1)*p(199)
    p(247) = p(4)*p(158)
    p(248) = p(1)*p(202)
    p(249) = p(4)*p(160)
    p(250) = p(1)*p(201)
    p(251) = p(2)*p(202) - p(249)
    p(252) = p(1)*p(203)
    p(253) = p(1)*p(204)
    p(254) = p(1)*p(205)
    p(255) = p(1)*p(206)
    p(256) = p(1)*p(207)
    p(257) = p(1)*p(208)
    p(258) = p(1)*p(209)
    p(259) = p(1)*p(210)
    p(260) = p(1)*p(211)
    p(261) = p(1)*p(212)
    p(262) = p(1)*p(213)
    p(263) = p(1)*p(214)
    p(264) = p(1)*p(215)
    p(265) = p(1)*p(216)
    p(266) = p(1)*p(217)
    p(267) = p(1)*p(218)
    p(268) = p(1)*p(219)
    p(269) = p(1)*p(220)
    p(270) = p(1)*p(221)
    p(271) = p(1)*p(222)
    p(272) = p(1)*p(239)
    p(273) = p(1)*p(223)
    p(274) = p(1)*p(224)
    p(275) = p(1)*p(225)
    p(276) = p(1)*p(226)
    p(277) = p(1)*p(241)
    p(278) = p(1)*p(227)
    p(279) = p(1)*p(228)
    p(280) = p(1)*p(229)
    p(281) = p(1)*p(243)
    p(282) = p(1)*p(230)
    p(283) = p(1)*p(231)
    p(284) = p(1)*p(245)
    p(285) = p(1)*p(232)
    p(286) = p(1)*p(247)
    p(287) = p(1)*p(249)
    p(288) = p(1)*p(233)
    p(289) = p(1)*p(234)
    p(290) = p(1)*p(235)
    p(291) = p(1)*p(236)
    p(292) = p(1)*p(237)
    p(293) = p(1)*p(238)
    p(294) = p(1)*p(240)
    p(295) = p(4)*p(192)
    p(296) = p(1)*p(242)
    p(297) = p(4)*p(194)
    p(298) = p(1)*p(244)
    p(299) = p(4)*p(196)
    p(300) = p(1)*p(246)
    p(301) = p(4)*p(198)
    p(302) = p(1)*p(248)
    p(303) = p(4)*p(200)
    p(304) = p(1)*p(251)
    p(305) = p(4)*p(202)
    p(306) = p(1)*p(250)
    p(307) = p(2)*p(251) - p(305)
    p(308) = p(1)*p(252)
    p(309) = p(1)*p(253)
    p(310) = p(1)*p(254)
    p(311) = p(1)*p(255)
    p(312) = p(1)*p(256)
    p(313) = p(1)*p(257)
    p(314) = p(1)*p(258)
    p(315) = p(1)*p(259)
    p(316) = p(1)*p(260)
    p(317) = p(1)*p(261)
    p(318) = p(1)*p(262)
    p(319) = p(1)*p(263)
    p(320) = p(1)*p(264)
    p(321) = p(1)*p(265)
    p(322) = p(1)*p(266)
    p(323) = p(1)*p(267)
    p(324) = p(1)*p(268)
    p(325) = p(1)*p(269)
    p(326) = p(1)*p(270)
    p(327) = p(1)*p(271)
    p(328) = p(1)*p(272)
    p(329) = p(1)*p(273)
    p(330) = p(1)*p(274)
    p(331) = p(1)*p(275)
    p(332) = p(1)*p(276)
    p(333) = p(1)*p(277)
    p(334) = p(1)*p(295)
    p(335) = p(1)*p(278)
    p(336) = p(1)*p(279)
    p(337) = p(1)*p(280)
    p(338) = p(1)*p(281)
    p(339) = p(1)*p(297)
    p(340) = p(1)*p(282)
    p(341) = p(1)*p(283)
    p(342) = p(1)*p(284)
    p(343) = p(1)*p(299)
    p(344) = p(1)*p(285)
    p(345) = p(1)*p(286)
    p(346) = p(1)*p(301)
    p(347) = p(1)*p(287)
    p(348) = p(1)*p(303)
    p(349) = p(1)*p(305)
    p(350) = p(1)*p(288)
    p(351) = p(1)*p(289)
    p(352) = p(1)*p(290)
    p(353) = p(1)*p(291)
    p(354) = p(1)*p(292)
    p(355) = p(1)*p(293)
    p(356) = p(1)*p(294)
    p(357) = p(4)*p(239)
    p(358) = p(1)*p(296)
    p(359) = p(4)*p(241)
    p(360) = p(1)*p(298)
    p(361) = p(4)*p(243)
    p(362) = p(1)*p(300)
    p(363) = p(4)*p(245)
    p(364) = p(1)*p(302)
    p(365) = p(4)*p(247)
    p(366) = p(1)*p(304)
    p(367) = p(4)*p(249)
    p(368) = p(1)*p(307)
    p(369) = p(4)*p(251)
    p(370) = p(1)*p(306)
    p(371) = p(2)*p(307) - p(369)
    p(372) = p(1)*p(308)
    p(373) = p(1)*p(309)
    p(374) = p(1)*p(310)
    p(375) = p(1)*p(311)
    p(376) = p(1)*p(312)
    p(377) = p(1)*p(313)
    p(378) = p(1)*p(314)
    p(379) = p(1)*p(315)
    p(380) = p(1)*p(316)
    p(381) = p(1)*p(317)
    p(382) = p(1)*p(318)
    p(383) = p(1)*p(319)
    p(384) = p(1)*p(320)
    p(385) = p(1)*p(321)
    p(386) = p(1)*p(322)
    p(387) = p(1)*p(323)
    p(388) = p(1)*p(324)
    p(389) = p(1)*p(325)
    p(390) = p(1)*p(326)
    p(391) = p(1)*p(327)
    p(392) = p(1)*p(328)
    p(393) = p(1)*p(329)
    p(394) = p(1)*p(330)
    p(395) = p(1)*p(331)
    p(396) = p(1)*p(332)
    p(397) = p(1)*p(333)
    p(398) = p(1)*p(334)
    p(399) = p(1)*p(357)
    p(400) = p(1)*p(335)
    p(401) = p(1)*p(336)
    p(402) = p(1)*p(337)
    p(403) = p(1)*p(338)
    p(404) = p(1)*p(339)
    p(405) = p(1)*p(359)
    p(406) = p(1)*p(340)
    p(407) = p(1)*p(341)
    p(408) = p(1)*p(342)
    p(409) = p(1)*p(343)
    p(410) = p(1)*p(361)
    p(411) = p(1)*p(344)
    p(412) = p(1)*p(345)
    p(413) = p(1)*p(346)
    p(414) = p(1)*p(363)
    p(415) = p(1)*p(347)
    p(416) = p(1)*p(348)
    p(417) = p(1)*p(365)
    p(418) = p(1)*p(349)
    p(419) = p(1)*p(367)
    p(420) = p(1)*p(369)
    p(421) = p(1)*p(350)
    p(422) = p(1)*p(351)
    p(423) = p(1)*p(352)
    p(424) = p(1)*p(353)
    p(425) = p(1)*p(354)
    p(426) = p(1)*p(355)
    p(427) = p(1)*p(356)
    p(428) = p(1)*p(358)
    p(429) = p(4)*p(295)
    p(430) = p(1)*p(360)
    p(431) = p(4)*p(297)
    p(432) = p(1)*p(362)
    p(433) = p(4)*p(299)
    p(434) = p(1)*p(364)
    p(435) = p(4)*p(301)
    p(436) = p(1)*p(366)
    p(437) = p(4)*p(303)
    p(438) = p(1)*p(368)
    p(439) = p(4)*p(305)
    p(440) = p(1)*p(371)
    p(441) = p(4)*p(307)
    p(442) = p(1)*p(370)
    p(443) = p(2)*p(371) - p(441)
    p(444) = p(1)*p(372)
    p(445) = p(1)*p(373)
    p(446) = p(1)*p(374)
    p(447) = p(1)*p(375)
    p(448) = p(1)*p(376)
    p(449) = p(1)*p(377)
    p(450) = p(1)*p(378)
    p(451) = p(1)*p(379)
    p(452) = p(1)*p(380)
    p(453) = p(1)*p(381)
    p(454) = p(1)*p(382)
    p(455) = p(1)*p(383)
    p(456) = p(1)*p(384)
    p(457) = p(1)*p(385)
    p(458) = p(1)*p(386)
    p(459) = p(1)*p(387)
    p(460) = p(1)*p(388)
    p(461) = p(1)*p(389)
    p(462) = p(1)*p(390)
    p(463) = p(1)*p(391)
    p(464) = p(1)*p(392)
    p(465) = p(1)*p(393)
    p(466) = p(1)*p(394)
    p(467) = p(1)*p(395)
    p(468) = p(1)*p(396)
    p(469) = p(1)*p(397)
    p(470) = p(1)*p(398)
    p(471) = p(1)*p(399)
    p(472) = p(1)*p(400)
    p(473) = p(1)*p(401)
    p(474) = p(1)*p(402)
    p(475) = p(1)*p(403)
    p(476) = p(1)*p(404)
    p(477) = p(1)*p(405)
    p(478) = p(1)*p(429)
    p(479) = p(1)*p(406)
    p(480) = p(1)*p(407)
    p(481) = p(1)*p(408)
    p(482) = p(1)*p(409)
    p(483) = p(1)*p(410)
    p(484) = p(1)*p(431)
    p(485) = p(1)*p(411)
    p(486) = p(1)*p(412)
    p(487) = p(1)*p(413)
    p(488) = p(1)*p(414)
    p(489) = p(1)*p(433)
    p(490) = p(1)*p(415)
    p(491) = p(1)*p(416)
    p(492) = p(1)*p(417)
    p(493) = p(1)*p(435)
    p(494) = p(1)*p(418)
    p(495) = p(1)*p(419)
    p(496) = p(1)*p(437)
    p(497) = p(1)*p(420)
    p(498) = p(1)*p(439)
    p(499) = p(1)*p(441)
    p(500) = p(1)*p(421)
    p(501) = p(1)*p(422)
    p(502) = p(1)*p(423)
    p(503) = p(1)*p(424)
    p(504) = p(1)*p(425)
    p(505) = p(1)*p(426)
    p(506) = p(1)*p(427)
    p(507) = p(1)*p(428)
    p(508) = p(4)*p(357)
    p(509) = p(1)*p(430)
    p(510) = p(4)*p(359)
    p(511) = p(1)*p(432)
    p(512) = p(4)*p(361)
    p(513) = p(1)*p(434)
    p(514) = p(4)*p(363)
    p(515) = p(1)*p(436)
    p(516) = p(4)*p(365)
    p(517) = p(1)*p(438)
    p(518) = p(4)*p(367)
    p(519) = p(1)*p(440)
    p(520) = p(4)*p(369)
    p(521) = p(1)*p(443)
    p(522) = p(4)*p(371)
    p(523) = p(1)*p(442)
    p(524) = p(2)*p(443) - p(522)
    p(525) = p(1)*p(444)
    p(526) = p(1)*p(445)
    p(527) = p(1)*p(446)
    p(528) = p(1)*p(447)
    p(529) = p(1)*p(448)
    p(530) = p(1)*p(449)
    p(531) = p(1)*p(450)
    p(532) = p(1)*p(451)
    p(533) = p(1)*p(452)
    p(534) = p(1)*p(453)
    p(535) = p(1)*p(454)
    p(536) = p(1)*p(455)
    p(537) = p(1)*p(456)
    p(538) = p(1)*p(457)
    p(539) = p(1)*p(458)
    p(540) = p(1)*p(459)
    p(541) = p(1)*p(460)
    p(542) = p(1)*p(461)
    p(543) = p(1)*p(462)
    p(544) = p(1)*p(463)
    p(545) = p(1)*p(464)
    p(546) = p(1)*p(465)
    p(547) = p(1)*p(466)
    p(548) = p(1)*p(467)
    p(549) = p(1)*p(468)
    p(550) = p(1)*p(469)
    p(551) = p(1)*p(470)
    p(552) = p(1)*p(471)
    p(553) = p(1)*p(472)
    p(554) = p(1)*p(473)
    p(555) = p(1)*p(474)
    p(556) = p(1)*p(475)
    p(557) = p(1)*p(476)
    p(558) = p(1)*p(477)
    p(559) = p(1)*p(478)
    p(560) = p(1)*p(508)
    p(561) = p(1)*p(479)
    p(562) = p(1)*p(480)
    p(563) = p(1)*p(481)
    p(564) = p(1)*p(482)
    p(565) = p(1)*p(483)
    p(566) = p(1)*p(484)
    p(567) = p(1)*p(510)
    p(568) = p(1)*p(485)
    p(569) = p(1)*p(486)
    p(570) = p(1)*p(487)
    p(571) = p(1)*p(488)
    p(572) = p(1)*p(489)
    p(573) = p(1)*p(512)
    p(574) = p(1)*p(490)
    p(575) = p(1)*p(491)
    p(576) = p(1)*p(492)
    p(577) = p(1)*p(493)
    p(578) = p(1)*p(514)
    p(579) = p(1)*p(494)
    p(580) = p(1)*p(495)
    p(581) = p(1)*p(496)
    p(582) = p(1)*p(516)
    p(583) = p(1)*p(497)
    p(584) = p(1)*p(498)
    p(585) = p(1)*p(518)
    p(586) = p(1)*p(499)
    p(587) = p(1)*p(520)
    p(588) = p(1)*p(522)
    p(589) = p(1)*p(500)
    p(590) = p(1)*p(501)
    p(591) = p(1)*p(502)
    p(592) = p(1)*p(503)
    p(593) = p(1)*p(504)
    p(594) = p(1)*p(505)
    p(595) = p(1)*p(506)
    p(596) = p(1)*p(507)
    p(597) = p(1)*p(509)
    p(598) = p(4)*p(429)
    p(599) = p(1)*p(511)
    p(600) = p(4)*p(431)
    p(601) = p(1)*p(513)
    p(602) = p(4)*p(433)
    p(603) = p(1)*p(515)
    p(604) = p(4)*p(435)
    p(605) = p(1)*p(517)
    p(606) = p(4)*p(437)
    p(607) = p(1)*p(519)
    p(608) = p(4)*p(439)
    p(609) = p(1)*p(521)
    p(610) = p(4)*p(441)
    p(611) = p(1)*p(524)
    p(612) = p(4)*p(443)
    p(613) = p(1)*p(523)
    p(614) = p(2)*p(524) - p(612)
    p(615) = p(1)*p(525)
    p(616) = p(1)*p(526)
    p(617) = p(1)*p(527)
    p(618) = p(1)*p(528)
    p(619) = p(1)*p(529)
    p(620) = p(1)*p(530)
    p(621) = p(1)*p(531)
    p(622) = p(1)*p(532)
    p(623) = p(1)*p(533)
    p(624) = p(1)*p(534)
    p(625) = p(1)*p(535)
    p(626) = p(1)*p(536)
    p(627) = p(1)*p(537)
    p(628) = p(1)*p(538)
    p(629) = p(1)*p(539)
    p(630) = p(1)*p(540)
    p(631) = p(1)*p(541)
    p(632) = p(1)*p(542)
    p(633) = p(1)*p(543)
    p(634) = p(1)*p(544)
    p(635) = p(1)*p(545)
    p(636) = p(1)*p(546)
    p(637) = p(1)*p(547)
    p(638) = p(1)*p(548)
    p(639) = p(1)*p(549)
    p(640) = p(1)*p(550)
    p(641) = p(1)*p(551)
    p(642) = p(1)*p(552)
    p(643) = p(1)*p(553)
    p(644) = p(1)*p(554)
    p(645) = p(1)*p(555)
    p(646) = p(1)*p(556)
    p(647) = p(1)*p(557)
    p(648) = p(1)*p(558)
    p(649) = p(1)*p(559)
    p(650) = p(1)*p(560)
    p(651) = p(1)*p(561)
    p(652) = p(1)*p(562)
    p(653) = p(1)*p(563)
    p(654) = p(1)*p(564)
    p(655) = p(1)*p(565)
    p(656) = p(1)*p(566)
    p(657) = p(1)*p(567)
    p(658) = p(1)*p(598)
    p(659) = p(1)*p(568)
    p(660) = p(1)*p(569)
    p(661) = p(1)*p(570)
    p(662) = p(1)*p(571)
    p(663) = p(1)*p(572)
    p(664) = p(1)*p(573)
    p(665) = p(1)*p(600)
    p(666) = p(1)*p(574)
    p(667) = p(1)*p(575)
    p(668) = p(1)*p(576)
    p(669) = p(1)*p(577)
    p(670) = p(1)*p(578)
    p(671) = p(1)*p(602)
    p(672) = p(1)*p(579)
    p(673) = p(1)*p(580)
    p(674) = p(1)*p(581)
    p(675) = p(1)*p(582)
    p(676) = p(1)*p(604)
    p(677) = p(1)*p(583)
    p(678) = p(1)*p(584)
    p(679) = p(1)*p(585)
    p(680) = p(1)*p(606)
    p(681) = p(1)*p(586)
    p(682) = p(1)*p(587)
    p(683) = p(1)*p(608)
    p(684) = p(1)*p(588)
    p(685) = p(1)*p(610)
    p(686) = p(1)*p(612)
    p(687) = p(1)*p(589)
    p(688) = p(1)*p(590)
    p(689) = p(1)*p(591)
    p(690) = p(1)*p(592)
    p(691) = p(1)*p(593)
    p(692) = p(1)*p(594)
    p(693) = p(1)*p(595)
    p(694) = p(1)*p(596)
    p(695) = p(1)*p(597)
    p(696) = p(4)*p(508)
    p(697) = p(1)*p(599)
    p(698) = p(4)*p(510)
    p(699) = p(1)*p(601)
    p(700) = p(4)*p(512)
    p(701) = p(1)*p(603)
    p(702) = p(4)*p(514)
    p(703) = p(1)*p(605)
    p(704) = p(4)*p(516)
    p(705) = p(1)*p(607)
    p(706) = p(4)*p(518)
    p(707) = p(1)*p(609)
    p(708) = p(4)*p(520)
    p(709) = p(1)*p(611)
    p(710) = p(4)*p(522)
    p(711) = p(1)*p(614)
    p(712) = p(4)*p(524)
    p(713) = p(1)*p(613)
    p(714) = p(2)*p(614) - p(712)
    p(715) = p(1)*p(615)
    p(716) = p(1)*p(616)
    p(717) = p(1)*p(617)
    p(718) = p(1)*p(618)
    p(719) = p(1)*p(619)
    p(720) = p(1)*p(620)
    p(721) = p(1)*p(621)
    p(722) = p(1)*p(622)
    p(723) = p(1)*p(623)
    p(724) = p(1)*p(624)
    p(725) = p(1)*p(625)
    p(726) = p(1)*p(626)
    p(727) = p(1)*p(627)
    p(728) = p(1)*p(628)
    p(729) = p(1)*p(629)
    p(730) = p(1)*p(630)
    p(731) = p(1)*p(631)
    p(732) = p(1)*p(632)
    p(733) = p(1)*p(633)
    p(734) = p(1)*p(634)
    p(735) = p(1)*p(635)
    p(736) = p(1)*p(636)
    p(737) = p(1)*p(637)
    p(738) = p(1)*p(638)
    p(739) = p(1)*p(639)
    p(740) = p(1)*p(640)
    p(741) = p(1)*p(641)
    p(742) = p(1)*p(642)
    p(743) = p(1)*p(643)
    p(744) = p(1)*p(644)
    p(745) = p(1)*p(645)
    p(746) = p(1)*p(646)
    p(747) = p(1)*p(647)
    p(748) = p(1)*p(648)
    p(749) = p(1)*p(649)
    p(750) = p(1)*p(650)
    p(751) = p(1)*p(651)
    p(752) = p(1)*p(652)
    p(753) = p(1)*p(653)
    p(754) = p(1)*p(654)
    p(755) = p(1)*p(655)
    p(756) = p(1)*p(656)
    p(757) = p(1)*p(657)
    p(758) = p(1)*p(658)
    p(759) = p(1)*p(696)
    p(760) = p(1)*p(659)
    p(761) = p(1)*p(660)
    p(762) = p(1)*p(661)
    p(763) = p(1)*p(662)
    p(764) = p(1)*p(663)
    p(765) = p(1)*p(664)
    p(766) = p(1)*p(665)
    p(767) = p(1)*p(698)
    p(768) = p(1)*p(666)
    p(769) = p(1)*p(667)
    p(770) = p(1)*p(668)
    p(771) = p(1)*p(669)
    p(772) = p(1)*p(670)
    p(773) = p(1)*p(671)
    p(774) = p(1)*p(700)
    p(775) = p(1)*p(672)
    p(776) = p(1)*p(673)
    p(777) = p(1)*p(674)
    p(778) = p(1)*p(675)
    p(779) = p(1)*p(676)
    p(780) = p(1)*p(702)
    p(781) = p(1)*p(677)
    p(782) = p(1)*p(678)
    p(783) = p(1)*p(679)
    p(784) = p(1)*p(680)
    p(785) = p(1)*p(704)
    p(786) = p(1)*p(681)
    p(787) = p(1)*p(682)
    p(788) = p(1)*p(683)
    p(789) = p(1)*p(706)
    p(790) = p(1)*p(684)
    p(791) = p(1)*p(685)
    p(792) = p(1)*p(708)
    p(793) = p(1)*p(686)
    p(794) = p(1)*p(710)
    p(795) = p(1)*p(712)
    p(796) = p(1)*p(687)
    p(797) = p(1)*p(688)
    p(798) = p(1)*p(689)
    p(799) = p(1)*p(690)
    p(800) = p(1)*p(691)
    p(801) = p(1)*p(692)
    p(802) = p(1)*p(693)
    p(803) = p(1)*p(694)
    p(804) = p(1)*p(695)
    p(805) = p(1)*p(697)
    p(806) = p(4)*p(598)
    p(807) = p(1)*p(699)
    p(808) = p(4)*p(600)
    p(809) = p(1)*p(701)
    p(810) = p(4)*p(602)
    p(811) = p(1)*p(703)
    p(812) = p(4)*p(604)
    p(813) = p(1)*p(705)
    p(814) = p(4)*p(606)
    p(815) = p(1)*p(707)
    p(816) = p(4)*p(608)
    p(817) = p(1)*p(709)
    p(818) = p(4)*p(610)
    p(819) = p(1)*p(711)
    p(820) = p(4)*p(612)
    p(821) = p(1)*p(714)
    p(822) = p(4)*p(614)
    p(823) = p(1)*p(713)
    p(824) = p(2)*p(714) - p(822)
    p(825) = p(1)*p(715)
    p(826) = p(1)*p(716)
    p(827) = p(1)*p(717)
    p(828) = p(1)*p(718)
    p(829) = p(1)*p(719)
    p(830) = p(1)*p(720)
    p(831) = p(1)*p(721)
    p(832) = p(1)*p(722)
    p(833) = p(1)*p(723)
    p(834) = p(1)*p(724)
    p(835) = p(1)*p(725)
    p(836) = p(1)*p(726)
    p(837) = p(1)*p(727)
    p(838) = p(1)*p(728)
    p(839) = p(1)*p(729)
    p(840) = p(1)*p(730)
    p(841) = p(1)*p(731)
    p(842) = p(1)*p(732)
    p(843) = p(1)*p(733)
    p(844) = p(1)*p(734)
    p(845) = p(1)*p(735)
    p(846) = p(1)*p(736)
    p(847) = p(1)*p(737)
    p(848) = p(1)*p(738)
    p(849) = p(1)*p(739)
    p(850) = p(1)*p(740)
    p(851) = p(1)*p(741)
    p(852) = p(1)*p(742)
    p(853) = p(1)*p(743)
    p(854) = p(1)*p(744)
    p(855) = p(1)*p(745)
    p(856) = p(1)*p(746)
    p(857) = p(1)*p(747)
    p(858) = p(1)*p(748)
    p(859) = p(1)*p(749)
    p(860) = p(1)*p(750)
    p(861) = p(1)*p(751)
    p(862) = p(1)*p(752)
    p(863) = p(1)*p(753)
    p(864) = p(1)*p(754)
    p(865) = p(1)*p(755)
    p(866) = p(1)*p(756)
    p(867) = p(1)*p(757)
    p(868) = p(1)*p(758)
    p(869) = p(1)*p(759)
    p(870) = p(1)*p(760)
    p(871) = p(1)*p(761)
    p(872) = p(1)*p(762)
    p(873) = p(1)*p(763)
    p(874) = p(1)*p(764)
    p(875) = p(1)*p(765)
    p(876) = p(1)*p(766)
    p(877) = p(1)*p(767)
    p(878) = p(1)*p(806)
    p(879) = p(1)*p(768)
    p(880) = p(1)*p(769)
    p(881) = p(1)*p(770)
    p(882) = p(1)*p(771)
    p(883) = p(1)*p(772)
    p(884) = p(1)*p(773)
    p(885) = p(1)*p(774)
    p(886) = p(1)*p(808)
    p(887) = p(1)*p(775)
    p(888) = p(1)*p(776)
    p(889) = p(1)*p(777)
    p(890) = p(1)*p(778)
    p(891) = p(1)*p(779)
    p(892) = p(1)*p(780)
    p(893) = p(1)*p(810)
    p(894) = p(1)*p(781)
    p(895) = p(1)*p(782)
    p(896) = p(1)*p(783)
    p(897) = p(1)*p(784)
    p(898) = p(1)*p(785)
    p(899) = p(1)*p(812)
    p(900) = p(1)*p(786)
    p(901) = p(1)*p(787)
    p(902) = p(1)*p(788)
    p(903) = p(1)*p(789)
    p(904) = p(1)*p(814)
    p(905) = p(1)*p(790)
    p(906) = p(1)*p(791)
    p(907) = p(1)*p(792)
    p(908) = p(1)*p(816)
    p(909) = p(1)*p(793)
    p(910) = p(1)*p(794)
    p(911) = p(1)*p(818)
    p(912) = p(1)*p(795)
    p(913) = p(1)*p(820)
    p(914) = p(1)*p(822)
    p(915) = p(1)*p(796)
    p(916) = p(1)*p(797)
    p(917) = p(1)*p(798)
    p(918) = p(1)*p(799)
    p(919) = p(1)*p(800)
    p(920) = p(1)*p(801)
    p(921) = p(1)*p(802)
    p(922) = p(1)*p(803)
    p(923) = p(1)*p(804)
    p(924) = p(1)*p(805)
    p(925) = p(4)*p(696)
    p(926) = p(1)*p(807)
    p(927) = p(4)*p(698)
    p(928) = p(1)*p(809)
    p(929) = p(4)*p(700)
    p(930) = p(1)*p(811)
    p(931) = p(4)*p(702)
    p(932) = p(1)*p(813)
    p(933) = p(4)*p(704)
    p(934) = p(1)*p(815)
    p(935) = p(4)*p(706)
    p(936) = p(1)*p(817)
    p(937) = p(4)*p(708)
    p(938) = p(1)*p(819)
    p(939) = p(4)*p(710)
    p(940) = p(1)*p(821)
    p(941) = p(4)*p(712)
    p(942) = p(1)*p(824)
    p(943) = p(4)*p(714)
    p(944) = p(1)*p(823)
    p(945) = p(2)*p(824) - p(943)

    return
  end subroutine evpoly

end module basis
module gradient
  implicit none

contains
  function demsav(drdx,c,m,p,flag) result(grad)
    implicit none
    real,dimension(9,3)::drdx
    real,dimension(0:945)::c
    real,dimension(0:4)::m
    real,dimension(0:945)::p
    real::grad
    integer::flag
    ! ::::::::::::::::::::
    real,dimension(0:945)::dp

    call dbemsav(drdx,dp,m,p,flag)
    grad = dot_product(dp,c)

    return
  end function demsav

  subroutine dbemsav(drdx,dp,m,p,flag)
    implicit none
    real,dimension(9,3),intent(in)::drdx
    real,dimension(0:945),intent(out)::dp
    real,dimension(0:4),intent(in)::m
    real,dimension(0:945),intent(in)::p
    integer::flag
    ! ::::::::::::::::::::
    real,dimension(0:4)::dm

    call devmono(drdx,dm,m,flag)
    call devpoly(dm,p,dp)

    return
  end subroutine dbemsav

  subroutine devmono(drdx,dm,m,flag)
    implicit none
    real,dimension(9,3),intent(in)::drdx
    real,dimension(0:4),intent(out)::dm
    real,dimension(0:4),intent(in)::m
    integer::flag
    !::::::::::::::::::::
    real::a

    a = 7.500d0

    dm(0) = 0.0D0
    dm(1) = -m(1)/a*drdx(flag,3)
    dm(2) = -m(2)/a*drdx(flag,2)
    dm(3) = -m(3)/a*drdx(flag,1)
    dm(4) = dm(2)*m(3) + m(2)*dm(3)

    return
  end subroutine devmono

  subroutine devpoly(dm,p,dp)
    implicit none
    real,dimension(0:4),intent(in)::dm
    real,dimension(0:945),intent(in)::p
    real,dimension(0:945),intent(out)::dp
    !::::::::::::::::::::

    dp(0) = dm(0)
    dp(1) = dm(1)
    dp(2) = dm(2) + dm(3)
    dp(3) = dp(1)*p(2) + p(1)*dp(2)
    dp(4) = dm(4)
    dp(5) = dp(1)*p(1) + p(1)*dp(1)
    dp(6) = dp(2)*p(2) + p(2)*dp(2) - dp(4) - dp(4)
    dp(7) = dp(1)*p(4) + p(1)*dp(4)
    dp(8) = dp(1)*p(3) + p(1)*dp(3)
    dp(9) = dp(1)*p(6) + p(1)*dp(6)
    dp(10) = dp(4)*p(2) + p(4)*dp(2)
    dp(11) = dp(1)*p(5) + p(1)*dp(5)
    dp(12) = dp(2)*p(6) + p(2)*dp(6) - dp(10)
    dp(13) = dp(1)*p(7) + p(1)*dp(7)
    dp(14) = dp(1)*p(10) + p(1)*dp(10)
    dp(15) = dp(1)*p(8) + p(1)*dp(8)
    dp(16) = dp(1)*p(9) + p(1)*dp(9)
    dp(17) = dp(4)*p(4) + p(4)*dp(4)
    dp(18) = dp(1)*p(12) + p(1)*dp(12)
    dp(19) = dp(4)*p(6) + p(4)*dp(6)
    dp(20) = dp(1)*p(11) + p(1)*dp(11)
    dp(21) = dp(2)*p(12) + p(2)*dp(12) - dp(19)
    dp(22) = dp(1)*p(13) + p(1)*dp(13)
    dp(23) = dp(1)*p(14) + p(1)*dp(14)
    dp(24) = dp(1)*p(17) + p(1)*dp(17)
    dp(25) = dp(1)*p(19) + p(1)*dp(19)
    dp(26) = dp(1)*p(15) + p(1)*dp(15)
    dp(27) = dp(1)*p(16) + p(1)*dp(16)
    dp(28) = dp(1)*p(18) + p(1)*dp(18)
    dp(29) = dp(4)*p(10) + p(4)*dp(10)
    dp(30) = dp(1)*p(21) + p(1)*dp(21)
    dp(31) = dp(4)*p(12) + p(4)*dp(12)
    dp(32) = dp(1)*p(20) + p(1)*dp(20)
    dp(33) = dp(2)*p(21) + p(2)*dp(21) - dp(31)
    dp(34) = dp(1)*p(22) + p(1)*dp(22)
    dp(35) = dp(1)*p(23) + p(1)*dp(23)
    dp(36) = dp(1)*p(24) + p(1)*dp(24)
    dp(37) = dp(1)*p(25) + p(1)*dp(25)
    dp(38) = dp(1)*p(29) + p(1)*dp(29)
    dp(39) = dp(1)*p(31) + p(1)*dp(31)
    dp(40) = dp(1)*p(26) + p(1)*dp(26)
    dp(41) = dp(1)*p(27) + p(1)*dp(27)
    dp(42) = dp(1)*p(28) + p(1)*dp(28)
    dp(43) = dp(4)*p(17) + p(4)*dp(17)
    dp(44) = dp(1)*p(30) + p(1)*dp(30)
    dp(45) = dp(4)*p(19) + p(4)*dp(19)
    dp(46) = dp(1)*p(33) + p(1)*dp(33)
    dp(47) = dp(4)*p(21) + p(4)*dp(21)
    dp(48) = dp(1)*p(32) + p(1)*dp(32)
    dp(49) = dp(2)*p(33) + p(2)*dp(33) - dp(47)
    dp(50) = dp(1)*p(34) + p(1)*dp(34)
    dp(51) = dp(1)*p(35) + p(1)*dp(35)
    dp(52) = dp(1)*p(36) + p(1)*dp(36)
    dp(53) = dp(1)*p(37) + p(1)*dp(37)
    dp(54) = dp(1)*p(38) + p(1)*dp(38)
    dp(55) = dp(1)*p(43) + p(1)*dp(43)
    dp(56) = dp(1)*p(39) + p(1)*dp(39)
    dp(57) = dp(1)*p(45) + p(1)*dp(45)
    dp(58) = dp(1)*p(47) + p(1)*dp(47)
    dp(59) = dp(1)*p(40) + p(1)*dp(40)
    dp(60) = dp(1)*p(41) + p(1)*dp(41)
    dp(61) = dp(1)*p(42) + p(1)*dp(42)
    dp(62) = dp(1)*p(44) + p(1)*dp(44)
    dp(63) = dp(4)*p(29) + p(4)*dp(29)
    dp(64) = dp(1)*p(46) + p(1)*dp(46)
    dp(65) = dp(4)*p(31) + p(4)*dp(31)
    dp(66) = dp(1)*p(49) + p(1)*dp(49)
    dp(67) = dp(4)*p(33) + p(4)*dp(33)
    dp(68) = dp(1)*p(48) + p(1)*dp(48)
    dp(69) = dp(2)*p(49) + p(2)*dp(49) - dp(67)
    dp(70) = dp(1)*p(50) + p(1)*dp(50)
    dp(71) = dp(1)*p(51) + p(1)*dp(51)
    dp(72) = dp(1)*p(52) + p(1)*dp(52)
    dp(73) = dp(1)*p(53) + p(1)*dp(53)
    dp(74) = dp(1)*p(54) + p(1)*dp(54)
    dp(75) = dp(1)*p(55) + p(1)*dp(55)
    dp(76) = dp(1)*p(56) + p(1)*dp(56)
    dp(77) = dp(1)*p(57) + p(1)*dp(57)
    dp(78) = dp(1)*p(63) + p(1)*dp(63)
    dp(79) = dp(1)*p(58) + p(1)*dp(58)
    dp(80) = dp(1)*p(65) + p(1)*dp(65)
    dp(81) = dp(1)*p(67) + p(1)*dp(67)
    dp(82) = dp(1)*p(59) + p(1)*dp(59)
    dp(83) = dp(1)*p(60) + p(1)*dp(60)
    dp(84) = dp(1)*p(61) + p(1)*dp(61)
    dp(85) = dp(1)*p(62) + p(1)*dp(62)
    dp(86) = dp(4)*p(43) + p(4)*dp(43)
    dp(87) = dp(1)*p(64) + p(1)*dp(64)
    dp(88) = dp(4)*p(45) + p(4)*dp(45)
    dp(89) = dp(1)*p(66) + p(1)*dp(66)
    dp(90) = dp(4)*p(47) + p(4)*dp(47)
    dp(91) = dp(1)*p(69) + p(1)*dp(69)
    dp(92) = dp(4)*p(49) + p(4)*dp(49)
    dp(93) = dp(1)*p(68) + p(1)*dp(68)
    dp(94) = dp(2)*p(69) + p(2)*dp(69) - dp(92)
    dp(95) = dp(1)*p(70) + p(1)*dp(70)
    dp(96) = dp(1)*p(71) + p(1)*dp(71)
    dp(97) = dp(1)*p(72) + p(1)*dp(72)
    dp(98) = dp(1)*p(73) + p(1)*dp(73)
    dp(99) = dp(1)*p(74) + p(1)*dp(74)
    dp(100) = dp(1)*p(75) + p(1)*dp(75)
    dp(101) = dp(1)*p(76) + p(1)*dp(76)
    dp(102) = dp(1)*p(77) + p(1)*dp(77)
    dp(103) = dp(1)*p(78) + p(1)*dp(78)
    dp(104) = dp(1)*p(86) + p(1)*dp(86)
    dp(105) = dp(1)*p(79) + p(1)*dp(79)
    dp(106) = dp(1)*p(80) + p(1)*dp(80)
    dp(107) = dp(1)*p(88) + p(1)*dp(88)
    dp(108) = dp(1)*p(81) + p(1)*dp(81)
    dp(109) = dp(1)*p(90) + p(1)*dp(90)
    dp(110) = dp(1)*p(92) + p(1)*dp(92)
    dp(111) = dp(1)*p(82) + p(1)*dp(82)
    dp(112) = dp(1)*p(83) + p(1)*dp(83)
    dp(113) = dp(1)*p(84) + p(1)*dp(84)
    dp(114) = dp(1)*p(85) + p(1)*dp(85)
    dp(115) = dp(1)*p(87) + p(1)*dp(87)
    dp(116) = dp(4)*p(63) + p(4)*dp(63)
    dp(117) = dp(1)*p(89) + p(1)*dp(89)
    dp(118) = dp(4)*p(65) + p(4)*dp(65)
    dp(119) = dp(1)*p(91) + p(1)*dp(91)
    dp(120) = dp(4)*p(67) + p(4)*dp(67)
    dp(121) = dp(1)*p(94) + p(1)*dp(94)
    dp(122) = dp(4)*p(69) + p(4)*dp(69)
    dp(123) = dp(1)*p(93) + p(1)*dp(93)
    dp(124) = dp(2)*p(94) + p(2)*dp(94) - dp(122)
    dp(125) = dp(1)*p(95) + p(1)*dp(95)
    dp(126) = dp(1)*p(96) + p(1)*dp(96)
    dp(127) = dp(1)*p(97) + p(1)*dp(97)
    dp(128) = dp(1)*p(98) + p(1)*dp(98)
    dp(129) = dp(1)*p(99) + p(1)*dp(99)
    dp(130) = dp(1)*p(100) + p(1)*dp(100)
    dp(131) = dp(1)*p(101) + p(1)*dp(101)
    dp(132) = dp(1)*p(102) + p(1)*dp(102)
    dp(133) = dp(1)*p(103) + p(1)*dp(103)
    dp(134) = dp(1)*p(104) + p(1)*dp(104)
    dp(135) = dp(1)*p(105) + p(1)*dp(105)
    dp(136) = dp(1)*p(106) + p(1)*dp(106)
    dp(137) = dp(1)*p(107) + p(1)*dp(107)
    dp(138) = dp(1)*p(116) + p(1)*dp(116)
    dp(139) = dp(1)*p(108) + p(1)*dp(108)
    dp(140) = dp(1)*p(109) + p(1)*dp(109)
    dp(141) = dp(1)*p(118) + p(1)*dp(118)
    dp(142) = dp(1)*p(110) + p(1)*dp(110)
    dp(143) = dp(1)*p(120) + p(1)*dp(120)
    dp(144) = dp(1)*p(122) + p(1)*dp(122)
    dp(145) = dp(1)*p(111) + p(1)*dp(111)
    dp(146) = dp(1)*p(112) + p(1)*dp(112)
    dp(147) = dp(1)*p(113) + p(1)*dp(113)
    dp(148) = dp(1)*p(114) + p(1)*dp(114)
    dp(149) = dp(1)*p(115) + p(1)*dp(115)
    dp(150) = dp(4)*p(86) + p(4)*dp(86)
    dp(151) = dp(1)*p(117) + p(1)*dp(117)
    dp(152) = dp(4)*p(88) + p(4)*dp(88)
    dp(153) = dp(1)*p(119) + p(1)*dp(119)
    dp(154) = dp(4)*p(90) + p(4)*dp(90)
    dp(155) = dp(1)*p(121) + p(1)*dp(121)
    dp(156) = dp(4)*p(92) + p(4)*dp(92)
    dp(157) = dp(1)*p(124) + p(1)*dp(124)
    dp(158) = dp(4)*p(94) + p(4)*dp(94)
    dp(159) = dp(1)*p(123) + p(1)*dp(123)
    dp(160) = dp(2)*p(124) + p(2)*dp(124) - dp(158)
    dp(161) = dp(1)*p(125) + p(1)*dp(125)
    dp(162) = dp(1)*p(126) + p(1)*dp(126)
    dp(163) = dp(1)*p(127) + p(1)*dp(127)
    dp(164) = dp(1)*p(128) + p(1)*dp(128)
    dp(165) = dp(1)*p(129) + p(1)*dp(129)
    dp(166) = dp(1)*p(130) + p(1)*dp(130)
    dp(167) = dp(1)*p(131) + p(1)*dp(131)
    dp(168) = dp(1)*p(132) + p(1)*dp(132)
    dp(169) = dp(1)*p(133) + p(1)*dp(133)
    dp(170) = dp(1)*p(134) + p(1)*dp(134)
    dp(171) = dp(1)*p(135) + p(1)*dp(135)
    dp(172) = dp(1)*p(136) + p(1)*dp(136)
    dp(173) = dp(1)*p(137) + p(1)*dp(137)
    dp(174) = dp(1)*p(138) + p(1)*dp(138)
    dp(175) = dp(1)*p(150) + p(1)*dp(150)
    dp(176) = dp(1)*p(139) + p(1)*dp(139)
    dp(177) = dp(1)*p(140) + p(1)*dp(140)
    dp(178) = dp(1)*p(141) + p(1)*dp(141)
    dp(179) = dp(1)*p(152) + p(1)*dp(152)
    dp(180) = dp(1)*p(142) + p(1)*dp(142)
    dp(181) = dp(1)*p(143) + p(1)*dp(143)
    dp(182) = dp(1)*p(154) + p(1)*dp(154)
    dp(183) = dp(1)*p(144) + p(1)*dp(144)
    dp(184) = dp(1)*p(156) + p(1)*dp(156)
    dp(185) = dp(1)*p(158) + p(1)*dp(158)
    dp(186) = dp(1)*p(145) + p(1)*dp(145)
    dp(187) = dp(1)*p(146) + p(1)*dp(146)
    dp(188) = dp(1)*p(147) + p(1)*dp(147)
    dp(189) = dp(1)*p(148) + p(1)*dp(148)
    dp(190) = dp(1)*p(149) + p(1)*dp(149)
    dp(191) = dp(1)*p(151) + p(1)*dp(151)
    dp(192) = dp(4)*p(116) + p(4)*dp(116)
    dp(193) = dp(1)*p(153) + p(1)*dp(153)
    dp(194) = dp(4)*p(118) + p(4)*dp(118)
    dp(195) = dp(1)*p(155) + p(1)*dp(155)
    dp(196) = dp(4)*p(120) + p(4)*dp(120)
    dp(197) = dp(1)*p(157) + p(1)*dp(157)
    dp(198) = dp(4)*p(122) + p(4)*dp(122)
    dp(199) = dp(1)*p(160) + p(1)*dp(160)
    dp(200) = dp(4)*p(124) + p(4)*dp(124)
    dp(201) = dp(1)*p(159) + p(1)*dp(159)
    dp(202) = dp(2)*p(160) + p(2)*dp(160) - dp(200)
    dp(203) = dp(1)*p(161) + p(1)*dp(161)
    dp(204) = dp(1)*p(162) + p(1)*dp(162)
    dp(205) = dp(1)*p(163) + p(1)*dp(163)
    dp(206) = dp(1)*p(164) + p(1)*dp(164)
    dp(207) = dp(1)*p(165) + p(1)*dp(165)
    dp(208) = dp(1)*p(166) + p(1)*dp(166)
    dp(209) = dp(1)*p(167) + p(1)*dp(167)
    dp(210) = dp(1)*p(168) + p(1)*dp(168)
    dp(211) = dp(1)*p(169) + p(1)*dp(169)
    dp(212) = dp(1)*p(170) + p(1)*dp(170)
    dp(213) = dp(1)*p(171) + p(1)*dp(171)
    dp(214) = dp(1)*p(172) + p(1)*dp(172)
    dp(215) = dp(1)*p(173) + p(1)*dp(173)
    dp(216) = dp(1)*p(174) + p(1)*dp(174)
    dp(217) = dp(1)*p(175) + p(1)*dp(175)
    dp(218) = dp(1)*p(176) + p(1)*dp(176)
    dp(219) = dp(1)*p(177) + p(1)*dp(177)
    dp(220) = dp(1)*p(178) + p(1)*dp(178)
    dp(221) = dp(1)*p(179) + p(1)*dp(179)
    dp(222) = dp(1)*p(192) + p(1)*dp(192)
    dp(223) = dp(1)*p(180) + p(1)*dp(180)
    dp(224) = dp(1)*p(181) + p(1)*dp(181)
    dp(225) = dp(1)*p(182) + p(1)*dp(182)
    dp(226) = dp(1)*p(194) + p(1)*dp(194)
    dp(227) = dp(1)*p(183) + p(1)*dp(183)
    dp(228) = dp(1)*p(184) + p(1)*dp(184)
    dp(229) = dp(1)*p(196) + p(1)*dp(196)
    dp(230) = dp(1)*p(185) + p(1)*dp(185)
    dp(231) = dp(1)*p(198) + p(1)*dp(198)
    dp(232) = dp(1)*p(200) + p(1)*dp(200)
    dp(233) = dp(1)*p(186) + p(1)*dp(186)
    dp(234) = dp(1)*p(187) + p(1)*dp(187)
    dp(235) = dp(1)*p(188) + p(1)*dp(188)
    dp(236) = dp(1)*p(189) + p(1)*dp(189)
    dp(237) = dp(1)*p(190) + p(1)*dp(190)
    dp(238) = dp(1)*p(191) + p(1)*dp(191)
    dp(239) = dp(4)*p(150) + p(4)*dp(150)
    dp(240) = dp(1)*p(193) + p(1)*dp(193)
    dp(241) = dp(4)*p(152) + p(4)*dp(152)
    dp(242) = dp(1)*p(195) + p(1)*dp(195)
    dp(243) = dp(4)*p(154) + p(4)*dp(154)
    dp(244) = dp(1)*p(197) + p(1)*dp(197)
    dp(245) = dp(4)*p(156) + p(4)*dp(156)
    dp(246) = dp(1)*p(199) + p(1)*dp(199)
    dp(247) = dp(4)*p(158) + p(4)*dp(158)
    dp(248) = dp(1)*p(202) + p(1)*dp(202)
    dp(249) = dp(4)*p(160) + p(4)*dp(160)
    dp(250) = dp(1)*p(201) + p(1)*dp(201)
    dp(251) = dp(2)*p(202) + p(2)*dp(202) - dp(249)
    dp(252) = dp(1)*p(203) + p(1)*dp(203)
    dp(253) = dp(1)*p(204) + p(1)*dp(204)
    dp(254) = dp(1)*p(205) + p(1)*dp(205)
    dp(255) = dp(1)*p(206) + p(1)*dp(206)
    dp(256) = dp(1)*p(207) + p(1)*dp(207)
    dp(257) = dp(1)*p(208) + p(1)*dp(208)
    dp(258) = dp(1)*p(209) + p(1)*dp(209)
    dp(259) = dp(1)*p(210) + p(1)*dp(210)
    dp(260) = dp(1)*p(211) + p(1)*dp(211)
    dp(261) = dp(1)*p(212) + p(1)*dp(212)
    dp(262) = dp(1)*p(213) + p(1)*dp(213)
    dp(263) = dp(1)*p(214) + p(1)*dp(214)
    dp(264) = dp(1)*p(215) + p(1)*dp(215)
    dp(265) = dp(1)*p(216) + p(1)*dp(216)
    dp(266) = dp(1)*p(217) + p(1)*dp(217)
    dp(267) = dp(1)*p(218) + p(1)*dp(218)
    dp(268) = dp(1)*p(219) + p(1)*dp(219)
    dp(269) = dp(1)*p(220) + p(1)*dp(220)
    dp(270) = dp(1)*p(221) + p(1)*dp(221)
    dp(271) = dp(1)*p(222) + p(1)*dp(222)
    dp(272) = dp(1)*p(239) + p(1)*dp(239)
    dp(273) = dp(1)*p(223) + p(1)*dp(223)
    dp(274) = dp(1)*p(224) + p(1)*dp(224)
    dp(275) = dp(1)*p(225) + p(1)*dp(225)
    dp(276) = dp(1)*p(226) + p(1)*dp(226)
    dp(277) = dp(1)*p(241) + p(1)*dp(241)
    dp(278) = dp(1)*p(227) + p(1)*dp(227)
    dp(279) = dp(1)*p(228) + p(1)*dp(228)
    dp(280) = dp(1)*p(229) + p(1)*dp(229)
    dp(281) = dp(1)*p(243) + p(1)*dp(243)
    dp(282) = dp(1)*p(230) + p(1)*dp(230)
    dp(283) = dp(1)*p(231) + p(1)*dp(231)
    dp(284) = dp(1)*p(245) + p(1)*dp(245)
    dp(285) = dp(1)*p(232) + p(1)*dp(232)
    dp(286) = dp(1)*p(247) + p(1)*dp(247)
    dp(287) = dp(1)*p(249) + p(1)*dp(249)
    dp(288) = dp(1)*p(233) + p(1)*dp(233)
    dp(289) = dp(1)*p(234) + p(1)*dp(234)
    dp(290) = dp(1)*p(235) + p(1)*dp(235)
    dp(291) = dp(1)*p(236) + p(1)*dp(236)
    dp(292) = dp(1)*p(237) + p(1)*dp(237)
    dp(293) = dp(1)*p(238) + p(1)*dp(238)
    dp(294) = dp(1)*p(240) + p(1)*dp(240)
    dp(295) = dp(4)*p(192) + p(4)*dp(192)
    dp(296) = dp(1)*p(242) + p(1)*dp(242)
    dp(297) = dp(4)*p(194) + p(4)*dp(194)
    dp(298) = dp(1)*p(244) + p(1)*dp(244)
    dp(299) = dp(4)*p(196) + p(4)*dp(196)
    dp(300) = dp(1)*p(246) + p(1)*dp(246)
    dp(301) = dp(4)*p(198) + p(4)*dp(198)
    dp(302) = dp(1)*p(248) + p(1)*dp(248)
    dp(303) = dp(4)*p(200) + p(4)*dp(200)
    dp(304) = dp(1)*p(251) + p(1)*dp(251)
    dp(305) = dp(4)*p(202) + p(4)*dp(202)
    dp(306) = dp(1)*p(250) + p(1)*dp(250)
    dp(307) = dp(2)*p(251) + p(2)*dp(251) - dp(305)
    dp(308) = dp(1)*p(252) + p(1)*dp(252)
    dp(309) = dp(1)*p(253) + p(1)*dp(253)
    dp(310) = dp(1)*p(254) + p(1)*dp(254)
    dp(311) = dp(1)*p(255) + p(1)*dp(255)
    dp(312) = dp(1)*p(256) + p(1)*dp(256)
    dp(313) = dp(1)*p(257) + p(1)*dp(257)
    dp(314) = dp(1)*p(258) + p(1)*dp(258)
    dp(315) = dp(1)*p(259) + p(1)*dp(259)
    dp(316) = dp(1)*p(260) + p(1)*dp(260)
    dp(317) = dp(1)*p(261) + p(1)*dp(261)
    dp(318) = dp(1)*p(262) + p(1)*dp(262)
    dp(319) = dp(1)*p(263) + p(1)*dp(263)
    dp(320) = dp(1)*p(264) + p(1)*dp(264)
    dp(321) = dp(1)*p(265) + p(1)*dp(265)
    dp(322) = dp(1)*p(266) + p(1)*dp(266)
    dp(323) = dp(1)*p(267) + p(1)*dp(267)
    dp(324) = dp(1)*p(268) + p(1)*dp(268)
    dp(325) = dp(1)*p(269) + p(1)*dp(269)
    dp(326) = dp(1)*p(270) + p(1)*dp(270)
    dp(327) = dp(1)*p(271) + p(1)*dp(271)
    dp(328) = dp(1)*p(272) + p(1)*dp(272)
    dp(329) = dp(1)*p(273) + p(1)*dp(273)
    dp(330) = dp(1)*p(274) + p(1)*dp(274)
    dp(331) = dp(1)*p(275) + p(1)*dp(275)
    dp(332) = dp(1)*p(276) + p(1)*dp(276)
    dp(333) = dp(1)*p(277) + p(1)*dp(277)
    dp(334) = dp(1)*p(295) + p(1)*dp(295)
    dp(335) = dp(1)*p(278) + p(1)*dp(278)
    dp(336) = dp(1)*p(279) + p(1)*dp(279)
    dp(337) = dp(1)*p(280) + p(1)*dp(280)
    dp(338) = dp(1)*p(281) + p(1)*dp(281)
    dp(339) = dp(1)*p(297) + p(1)*dp(297)
    dp(340) = dp(1)*p(282) + p(1)*dp(282)
    dp(341) = dp(1)*p(283) + p(1)*dp(283)
    dp(342) = dp(1)*p(284) + p(1)*dp(284)
    dp(343) = dp(1)*p(299) + p(1)*dp(299)
    dp(344) = dp(1)*p(285) + p(1)*dp(285)
    dp(345) = dp(1)*p(286) + p(1)*dp(286)
    dp(346) = dp(1)*p(301) + p(1)*dp(301)
    dp(347) = dp(1)*p(287) + p(1)*dp(287)
    dp(348) = dp(1)*p(303) + p(1)*dp(303)
    dp(349) = dp(1)*p(305) + p(1)*dp(305)
    dp(350) = dp(1)*p(288) + p(1)*dp(288)
    dp(351) = dp(1)*p(289) + p(1)*dp(289)
    dp(352) = dp(1)*p(290) + p(1)*dp(290)
    dp(353) = dp(1)*p(291) + p(1)*dp(291)
    dp(354) = dp(1)*p(292) + p(1)*dp(292)
    dp(355) = dp(1)*p(293) + p(1)*dp(293)
    dp(356) = dp(1)*p(294) + p(1)*dp(294)
    dp(357) = dp(4)*p(239) + p(4)*dp(239)
    dp(358) = dp(1)*p(296) + p(1)*dp(296)
    dp(359) = dp(4)*p(241) + p(4)*dp(241)
    dp(360) = dp(1)*p(298) + p(1)*dp(298)
    dp(361) = dp(4)*p(243) + p(4)*dp(243)
    dp(362) = dp(1)*p(300) + p(1)*dp(300)
    dp(363) = dp(4)*p(245) + p(4)*dp(245)
    dp(364) = dp(1)*p(302) + p(1)*dp(302)
    dp(365) = dp(4)*p(247) + p(4)*dp(247)
    dp(366) = dp(1)*p(304) + p(1)*dp(304)
    dp(367) = dp(4)*p(249) + p(4)*dp(249)
    dp(368) = dp(1)*p(307) + p(1)*dp(307)
    dp(369) = dp(4)*p(251) + p(4)*dp(251)
    dp(370) = dp(1)*p(306) + p(1)*dp(306)
    dp(371) = dp(2)*p(307) + p(2)*dp(307) - dp(369)
    dp(372) = dp(1)*p(308) + p(1)*dp(308)
    dp(373) = dp(1)*p(309) + p(1)*dp(309)
    dp(374) = dp(1)*p(310) + p(1)*dp(310)
    dp(375) = dp(1)*p(311) + p(1)*dp(311)
    dp(376) = dp(1)*p(312) + p(1)*dp(312)
    dp(377) = dp(1)*p(313) + p(1)*dp(313)
    dp(378) = dp(1)*p(314) + p(1)*dp(314)
    dp(379) = dp(1)*p(315) + p(1)*dp(315)
    dp(380) = dp(1)*p(316) + p(1)*dp(316)
    dp(381) = dp(1)*p(317) + p(1)*dp(317)
    dp(382) = dp(1)*p(318) + p(1)*dp(318)
    dp(383) = dp(1)*p(319) + p(1)*dp(319)
    dp(384) = dp(1)*p(320) + p(1)*dp(320)
    dp(385) = dp(1)*p(321) + p(1)*dp(321)
    dp(386) = dp(1)*p(322) + p(1)*dp(322)
    dp(387) = dp(1)*p(323) + p(1)*dp(323)
    dp(388) = dp(1)*p(324) + p(1)*dp(324)
    dp(389) = dp(1)*p(325) + p(1)*dp(325)
    dp(390) = dp(1)*p(326) + p(1)*dp(326)
    dp(391) = dp(1)*p(327) + p(1)*dp(327)
    dp(392) = dp(1)*p(328) + p(1)*dp(328)
    dp(393) = dp(1)*p(329) + p(1)*dp(329)
    dp(394) = dp(1)*p(330) + p(1)*dp(330)
    dp(395) = dp(1)*p(331) + p(1)*dp(331)
    dp(396) = dp(1)*p(332) + p(1)*dp(332)
    dp(397) = dp(1)*p(333) + p(1)*dp(333)
    dp(398) = dp(1)*p(334) + p(1)*dp(334)
    dp(399) = dp(1)*p(357) + p(1)*dp(357)
    dp(400) = dp(1)*p(335) + p(1)*dp(335)
    dp(401) = dp(1)*p(336) + p(1)*dp(336)
    dp(402) = dp(1)*p(337) + p(1)*dp(337)
    dp(403) = dp(1)*p(338) + p(1)*dp(338)
    dp(404) = dp(1)*p(339) + p(1)*dp(339)
    dp(405) = dp(1)*p(359) + p(1)*dp(359)
    dp(406) = dp(1)*p(340) + p(1)*dp(340)
    dp(407) = dp(1)*p(341) + p(1)*dp(341)
    dp(408) = dp(1)*p(342) + p(1)*dp(342)
    dp(409) = dp(1)*p(343) + p(1)*dp(343)
    dp(410) = dp(1)*p(361) + p(1)*dp(361)
    dp(411) = dp(1)*p(344) + p(1)*dp(344)
    dp(412) = dp(1)*p(345) + p(1)*dp(345)
    dp(413) = dp(1)*p(346) + p(1)*dp(346)
    dp(414) = dp(1)*p(363) + p(1)*dp(363)
    dp(415) = dp(1)*p(347) + p(1)*dp(347)
    dp(416) = dp(1)*p(348) + p(1)*dp(348)
    dp(417) = dp(1)*p(365) + p(1)*dp(365)
    dp(418) = dp(1)*p(349) + p(1)*dp(349)
    dp(419) = dp(1)*p(367) + p(1)*dp(367)
    dp(420) = dp(1)*p(369) + p(1)*dp(369)
    dp(421) = dp(1)*p(350) + p(1)*dp(350)
    dp(422) = dp(1)*p(351) + p(1)*dp(351)
    dp(423) = dp(1)*p(352) + p(1)*dp(352)
    dp(424) = dp(1)*p(353) + p(1)*dp(353)
    dp(425) = dp(1)*p(354) + p(1)*dp(354)
    dp(426) = dp(1)*p(355) + p(1)*dp(355)
    dp(427) = dp(1)*p(356) + p(1)*dp(356)
    dp(428) = dp(1)*p(358) + p(1)*dp(358)
    dp(429) = dp(4)*p(295) + p(4)*dp(295)
    dp(430) = dp(1)*p(360) + p(1)*dp(360)
    dp(431) = dp(4)*p(297) + p(4)*dp(297)
    dp(432) = dp(1)*p(362) + p(1)*dp(362)
    dp(433) = dp(4)*p(299) + p(4)*dp(299)
    dp(434) = dp(1)*p(364) + p(1)*dp(364)
    dp(435) = dp(4)*p(301) + p(4)*dp(301)
    dp(436) = dp(1)*p(366) + p(1)*dp(366)
    dp(437) = dp(4)*p(303) + p(4)*dp(303)
    dp(438) = dp(1)*p(368) + p(1)*dp(368)
    dp(439) = dp(4)*p(305) + p(4)*dp(305)
    dp(440) = dp(1)*p(371) + p(1)*dp(371)
    dp(441) = dp(4)*p(307) + p(4)*dp(307)
    dp(442) = dp(1)*p(370) + p(1)*dp(370)
    dp(443) = dp(2)*p(371) + p(2)*dp(371) - dp(441)
    dp(444) = dp(1)*p(372) + p(1)*dp(372)
    dp(445) = dp(1)*p(373) + p(1)*dp(373)
    dp(446) = dp(1)*p(374) + p(1)*dp(374)
    dp(447) = dp(1)*p(375) + p(1)*dp(375)
    dp(448) = dp(1)*p(376) + p(1)*dp(376)
    dp(449) = dp(1)*p(377) + p(1)*dp(377)
    dp(450) = dp(1)*p(378) + p(1)*dp(378)
    dp(451) = dp(1)*p(379) + p(1)*dp(379)
    dp(452) = dp(1)*p(380) + p(1)*dp(380)
    dp(453) = dp(1)*p(381) + p(1)*dp(381)
    dp(454) = dp(1)*p(382) + p(1)*dp(382)
    dp(455) = dp(1)*p(383) + p(1)*dp(383)
    dp(456) = dp(1)*p(384) + p(1)*dp(384)
    dp(457) = dp(1)*p(385) + p(1)*dp(385)
    dp(458) = dp(1)*p(386) + p(1)*dp(386)
    dp(459) = dp(1)*p(387) + p(1)*dp(387)
    dp(460) = dp(1)*p(388) + p(1)*dp(388)
    dp(461) = dp(1)*p(389) + p(1)*dp(389)
    dp(462) = dp(1)*p(390) + p(1)*dp(390)
    dp(463) = dp(1)*p(391) + p(1)*dp(391)
    dp(464) = dp(1)*p(392) + p(1)*dp(392)
    dp(465) = dp(1)*p(393) + p(1)*dp(393)
    dp(466) = dp(1)*p(394) + p(1)*dp(394)
    dp(467) = dp(1)*p(395) + p(1)*dp(395)
    dp(468) = dp(1)*p(396) + p(1)*dp(396)
    dp(469) = dp(1)*p(397) + p(1)*dp(397)
    dp(470) = dp(1)*p(398) + p(1)*dp(398)
    dp(471) = dp(1)*p(399) + p(1)*dp(399)
    dp(472) = dp(1)*p(400) + p(1)*dp(400)
    dp(473) = dp(1)*p(401) + p(1)*dp(401)
    dp(474) = dp(1)*p(402) + p(1)*dp(402)
    dp(475) = dp(1)*p(403) + p(1)*dp(403)
    dp(476) = dp(1)*p(404) + p(1)*dp(404)
    dp(477) = dp(1)*p(405) + p(1)*dp(405)
    dp(478) = dp(1)*p(429) + p(1)*dp(429)
    dp(479) = dp(1)*p(406) + p(1)*dp(406)
    dp(480) = dp(1)*p(407) + p(1)*dp(407)
    dp(481) = dp(1)*p(408) + p(1)*dp(408)
    dp(482) = dp(1)*p(409) + p(1)*dp(409)
    dp(483) = dp(1)*p(410) + p(1)*dp(410)
    dp(484) = dp(1)*p(431) + p(1)*dp(431)
    dp(485) = dp(1)*p(411) + p(1)*dp(411)
    dp(486) = dp(1)*p(412) + p(1)*dp(412)
    dp(487) = dp(1)*p(413) + p(1)*dp(413)
    dp(488) = dp(1)*p(414) + p(1)*dp(414)
    dp(489) = dp(1)*p(433) + p(1)*dp(433)
    dp(490) = dp(1)*p(415) + p(1)*dp(415)
    dp(491) = dp(1)*p(416) + p(1)*dp(416)
    dp(492) = dp(1)*p(417) + p(1)*dp(417)
    dp(493) = dp(1)*p(435) + p(1)*dp(435)
    dp(494) = dp(1)*p(418) + p(1)*dp(418)
    dp(495) = dp(1)*p(419) + p(1)*dp(419)
    dp(496) = dp(1)*p(437) + p(1)*dp(437)
    dp(497) = dp(1)*p(420) + p(1)*dp(420)
    dp(498) = dp(1)*p(439) + p(1)*dp(439)
    dp(499) = dp(1)*p(441) + p(1)*dp(441)
    dp(500) = dp(1)*p(421) + p(1)*dp(421)
    dp(501) = dp(1)*p(422) + p(1)*dp(422)
    dp(502) = dp(1)*p(423) + p(1)*dp(423)
    dp(503) = dp(1)*p(424) + p(1)*dp(424)
    dp(504) = dp(1)*p(425) + p(1)*dp(425)
    dp(505) = dp(1)*p(426) + p(1)*dp(426)
    dp(506) = dp(1)*p(427) + p(1)*dp(427)
    dp(507) = dp(1)*p(428) + p(1)*dp(428)
    dp(508) = dp(4)*p(357) + p(4)*dp(357)
    dp(509) = dp(1)*p(430) + p(1)*dp(430)
    dp(510) = dp(4)*p(359) + p(4)*dp(359)
    dp(511) = dp(1)*p(432) + p(1)*dp(432)
    dp(512) = dp(4)*p(361) + p(4)*dp(361)
    dp(513) = dp(1)*p(434) + p(1)*dp(434)
    dp(514) = dp(4)*p(363) + p(4)*dp(363)
    dp(515) = dp(1)*p(436) + p(1)*dp(436)
    dp(516) = dp(4)*p(365) + p(4)*dp(365)
    dp(517) = dp(1)*p(438) + p(1)*dp(438)
    dp(518) = dp(4)*p(367) + p(4)*dp(367)
    dp(519) = dp(1)*p(440) + p(1)*dp(440)
    dp(520) = dp(4)*p(369) + p(4)*dp(369)
    dp(521) = dp(1)*p(443) + p(1)*dp(443)
    dp(522) = dp(4)*p(371) + p(4)*dp(371)
    dp(523) = dp(1)*p(442) + p(1)*dp(442)
    dp(524) = dp(2)*p(443) + p(2)*dp(443) - dp(522)
    dp(525) = dp(1)*p(444) + p(1)*dp(444)
    dp(526) = dp(1)*p(445) + p(1)*dp(445)
    dp(527) = dp(1)*p(446) + p(1)*dp(446)
    dp(528) = dp(1)*p(447) + p(1)*dp(447)
    dp(529) = dp(1)*p(448) + p(1)*dp(448)
    dp(530) = dp(1)*p(449) + p(1)*dp(449)
    dp(531) = dp(1)*p(450) + p(1)*dp(450)
    dp(532) = dp(1)*p(451) + p(1)*dp(451)
    dp(533) = dp(1)*p(452) + p(1)*dp(452)
    dp(534) = dp(1)*p(453) + p(1)*dp(453)
    dp(535) = dp(1)*p(454) + p(1)*dp(454)
    dp(536) = dp(1)*p(455) + p(1)*dp(455)
    dp(537) = dp(1)*p(456) + p(1)*dp(456)
    dp(538) = dp(1)*p(457) + p(1)*dp(457)
    dp(539) = dp(1)*p(458) + p(1)*dp(458)
    dp(540) = dp(1)*p(459) + p(1)*dp(459)
    dp(541) = dp(1)*p(460) + p(1)*dp(460)
    dp(542) = dp(1)*p(461) + p(1)*dp(461)
    dp(543) = dp(1)*p(462) + p(1)*dp(462)
    dp(544) = dp(1)*p(463) + p(1)*dp(463)
    dp(545) = dp(1)*p(464) + p(1)*dp(464)
    dp(546) = dp(1)*p(465) + p(1)*dp(465)
    dp(547) = dp(1)*p(466) + p(1)*dp(466)
    dp(548) = dp(1)*p(467) + p(1)*dp(467)
    dp(549) = dp(1)*p(468) + p(1)*dp(468)
    dp(550) = dp(1)*p(469) + p(1)*dp(469)
    dp(551) = dp(1)*p(470) + p(1)*dp(470)
    dp(552) = dp(1)*p(471) + p(1)*dp(471)
    dp(553) = dp(1)*p(472) + p(1)*dp(472)
    dp(554) = dp(1)*p(473) + p(1)*dp(473)
    dp(555) = dp(1)*p(474) + p(1)*dp(474)
    dp(556) = dp(1)*p(475) + p(1)*dp(475)
    dp(557) = dp(1)*p(476) + p(1)*dp(476)
    dp(558) = dp(1)*p(477) + p(1)*dp(477)
    dp(559) = dp(1)*p(478) + p(1)*dp(478)
    dp(560) = dp(1)*p(508) + p(1)*dp(508)
    dp(561) = dp(1)*p(479) + p(1)*dp(479)
    dp(562) = dp(1)*p(480) + p(1)*dp(480)
    dp(563) = dp(1)*p(481) + p(1)*dp(481)
    dp(564) = dp(1)*p(482) + p(1)*dp(482)
    dp(565) = dp(1)*p(483) + p(1)*dp(483)
    dp(566) = dp(1)*p(484) + p(1)*dp(484)
    dp(567) = dp(1)*p(510) + p(1)*dp(510)
    dp(568) = dp(1)*p(485) + p(1)*dp(485)
    dp(569) = dp(1)*p(486) + p(1)*dp(486)
    dp(570) = dp(1)*p(487) + p(1)*dp(487)
    dp(571) = dp(1)*p(488) + p(1)*dp(488)
    dp(572) = dp(1)*p(489) + p(1)*dp(489)
    dp(573) = dp(1)*p(512) + p(1)*dp(512)
    dp(574) = dp(1)*p(490) + p(1)*dp(490)
    dp(575) = dp(1)*p(491) + p(1)*dp(491)
    dp(576) = dp(1)*p(492) + p(1)*dp(492)
    dp(577) = dp(1)*p(493) + p(1)*dp(493)
    dp(578) = dp(1)*p(514) + p(1)*dp(514)
    dp(579) = dp(1)*p(494) + p(1)*dp(494)
    dp(580) = dp(1)*p(495) + p(1)*dp(495)
    dp(581) = dp(1)*p(496) + p(1)*dp(496)
    dp(582) = dp(1)*p(516) + p(1)*dp(516)
    dp(583) = dp(1)*p(497) + p(1)*dp(497)
    dp(584) = dp(1)*p(498) + p(1)*dp(498)
    dp(585) = dp(1)*p(518) + p(1)*dp(518)
    dp(586) = dp(1)*p(499) + p(1)*dp(499)
    dp(587) = dp(1)*p(520) + p(1)*dp(520)
    dp(588) = dp(1)*p(522) + p(1)*dp(522)
    dp(589) = dp(1)*p(500) + p(1)*dp(500)
    dp(590) = dp(1)*p(501) + p(1)*dp(501)
    dp(591) = dp(1)*p(502) + p(1)*dp(502)
    dp(592) = dp(1)*p(503) + p(1)*dp(503)
    dp(593) = dp(1)*p(504) + p(1)*dp(504)
    dp(594) = dp(1)*p(505) + p(1)*dp(505)
    dp(595) = dp(1)*p(506) + p(1)*dp(506)
    dp(596) = dp(1)*p(507) + p(1)*dp(507)
    dp(597) = dp(1)*p(509) + p(1)*dp(509)
    dp(598) = dp(4)*p(429) + p(4)*dp(429)
    dp(599) = dp(1)*p(511) + p(1)*dp(511)
    dp(600) = dp(4)*p(431) + p(4)*dp(431)
    dp(601) = dp(1)*p(513) + p(1)*dp(513)
    dp(602) = dp(4)*p(433) + p(4)*dp(433)
    dp(603) = dp(1)*p(515) + p(1)*dp(515)
    dp(604) = dp(4)*p(435) + p(4)*dp(435)
    dp(605) = dp(1)*p(517) + p(1)*dp(517)
    dp(606) = dp(4)*p(437) + p(4)*dp(437)
    dp(607) = dp(1)*p(519) + p(1)*dp(519)
    dp(608) = dp(4)*p(439) + p(4)*dp(439)
    dp(609) = dp(1)*p(521) + p(1)*dp(521)
    dp(610) = dp(4)*p(441) + p(4)*dp(441)
    dp(611) = dp(1)*p(524) + p(1)*dp(524)
    dp(612) = dp(4)*p(443) + p(4)*dp(443)
    dp(613) = dp(1)*p(523) + p(1)*dp(523)
    dp(614) = dp(2)*p(524) + p(2)*dp(524) - dp(612)
    dp(615) = dp(1)*p(525) + p(1)*dp(525)
    dp(616) = dp(1)*p(526) + p(1)*dp(526)
    dp(617) = dp(1)*p(527) + p(1)*dp(527)
    dp(618) = dp(1)*p(528) + p(1)*dp(528)
    dp(619) = dp(1)*p(529) + p(1)*dp(529)
    dp(620) = dp(1)*p(530) + p(1)*dp(530)
    dp(621) = dp(1)*p(531) + p(1)*dp(531)
    dp(622) = dp(1)*p(532) + p(1)*dp(532)
    dp(623) = dp(1)*p(533) + p(1)*dp(533)
    dp(624) = dp(1)*p(534) + p(1)*dp(534)
    dp(625) = dp(1)*p(535) + p(1)*dp(535)
    dp(626) = dp(1)*p(536) + p(1)*dp(536)
    dp(627) = dp(1)*p(537) + p(1)*dp(537)
    dp(628) = dp(1)*p(538) + p(1)*dp(538)
    dp(629) = dp(1)*p(539) + p(1)*dp(539)
    dp(630) = dp(1)*p(540) + p(1)*dp(540)
    dp(631) = dp(1)*p(541) + p(1)*dp(541)
    dp(632) = dp(1)*p(542) + p(1)*dp(542)
    dp(633) = dp(1)*p(543) + p(1)*dp(543)
    dp(634) = dp(1)*p(544) + p(1)*dp(544)
    dp(635) = dp(1)*p(545) + p(1)*dp(545)
    dp(636) = dp(1)*p(546) + p(1)*dp(546)
    dp(637) = dp(1)*p(547) + p(1)*dp(547)
    dp(638) = dp(1)*p(548) + p(1)*dp(548)
    dp(639) = dp(1)*p(549) + p(1)*dp(549)
    dp(640) = dp(1)*p(550) + p(1)*dp(550)
    dp(641) = dp(1)*p(551) + p(1)*dp(551)
    dp(642) = dp(1)*p(552) + p(1)*dp(552)
    dp(643) = dp(1)*p(553) + p(1)*dp(553)
    dp(644) = dp(1)*p(554) + p(1)*dp(554)
    dp(645) = dp(1)*p(555) + p(1)*dp(555)
    dp(646) = dp(1)*p(556) + p(1)*dp(556)
    dp(647) = dp(1)*p(557) + p(1)*dp(557)
    dp(648) = dp(1)*p(558) + p(1)*dp(558)
    dp(649) = dp(1)*p(559) + p(1)*dp(559)
    dp(650) = dp(1)*p(560) + p(1)*dp(560)
    dp(651) = dp(1)*p(561) + p(1)*dp(561)
    dp(652) = dp(1)*p(562) + p(1)*dp(562)
    dp(653) = dp(1)*p(563) + p(1)*dp(563)
    dp(654) = dp(1)*p(564) + p(1)*dp(564)
    dp(655) = dp(1)*p(565) + p(1)*dp(565)
    dp(656) = dp(1)*p(566) + p(1)*dp(566)
    dp(657) = dp(1)*p(567) + p(1)*dp(567)
    dp(658) = dp(1)*p(598) + p(1)*dp(598)
    dp(659) = dp(1)*p(568) + p(1)*dp(568)
    dp(660) = dp(1)*p(569) + p(1)*dp(569)
    dp(661) = dp(1)*p(570) + p(1)*dp(570)
    dp(662) = dp(1)*p(571) + p(1)*dp(571)
    dp(663) = dp(1)*p(572) + p(1)*dp(572)
    dp(664) = dp(1)*p(573) + p(1)*dp(573)
    dp(665) = dp(1)*p(600) + p(1)*dp(600)
    dp(666) = dp(1)*p(574) + p(1)*dp(574)
    dp(667) = dp(1)*p(575) + p(1)*dp(575)
    dp(668) = dp(1)*p(576) + p(1)*dp(576)
    dp(669) = dp(1)*p(577) + p(1)*dp(577)
    dp(670) = dp(1)*p(578) + p(1)*dp(578)
    dp(671) = dp(1)*p(602) + p(1)*dp(602)
    dp(672) = dp(1)*p(579) + p(1)*dp(579)
    dp(673) = dp(1)*p(580) + p(1)*dp(580)
    dp(674) = dp(1)*p(581) + p(1)*dp(581)
    dp(675) = dp(1)*p(582) + p(1)*dp(582)
    dp(676) = dp(1)*p(604) + p(1)*dp(604)
    dp(677) = dp(1)*p(583) + p(1)*dp(583)
    dp(678) = dp(1)*p(584) + p(1)*dp(584)
    dp(679) = dp(1)*p(585) + p(1)*dp(585)
    dp(680) = dp(1)*p(606) + p(1)*dp(606)
    dp(681) = dp(1)*p(586) + p(1)*dp(586)
    dp(682) = dp(1)*p(587) + p(1)*dp(587)
    dp(683) = dp(1)*p(608) + p(1)*dp(608)
    dp(684) = dp(1)*p(588) + p(1)*dp(588)
    dp(685) = dp(1)*p(610) + p(1)*dp(610)
    dp(686) = dp(1)*p(612) + p(1)*dp(612)
    dp(687) = dp(1)*p(589) + p(1)*dp(589)
    dp(688) = dp(1)*p(590) + p(1)*dp(590)
    dp(689) = dp(1)*p(591) + p(1)*dp(591)
    dp(690) = dp(1)*p(592) + p(1)*dp(592)
    dp(691) = dp(1)*p(593) + p(1)*dp(593)
    dp(692) = dp(1)*p(594) + p(1)*dp(594)
    dp(693) = dp(1)*p(595) + p(1)*dp(595)
    dp(694) = dp(1)*p(596) + p(1)*dp(596)
    dp(695) = dp(1)*p(597) + p(1)*dp(597)
    dp(696) = dp(4)*p(508) + p(4)*dp(508)
    dp(697) = dp(1)*p(599) + p(1)*dp(599)
    dp(698) = dp(4)*p(510) + p(4)*dp(510)
    dp(699) = dp(1)*p(601) + p(1)*dp(601)
    dp(700) = dp(4)*p(512) + p(4)*dp(512)
    dp(701) = dp(1)*p(603) + p(1)*dp(603)
    dp(702) = dp(4)*p(514) + p(4)*dp(514)
    dp(703) = dp(1)*p(605) + p(1)*dp(605)
    dp(704) = dp(4)*p(516) + p(4)*dp(516)
    dp(705) = dp(1)*p(607) + p(1)*dp(607)
    dp(706) = dp(4)*p(518) + p(4)*dp(518)
    dp(707) = dp(1)*p(609) + p(1)*dp(609)
    dp(708) = dp(4)*p(520) + p(4)*dp(520)
    dp(709) = dp(1)*p(611) + p(1)*dp(611)
    dp(710) = dp(4)*p(522) + p(4)*dp(522)
    dp(711) = dp(1)*p(614) + p(1)*dp(614)
    dp(712) = dp(4)*p(524) + p(4)*dp(524)
    dp(713) = dp(1)*p(613) + p(1)*dp(613)
    dp(714) = dp(2)*p(614) + p(2)*dp(614) - dp(712)
    dp(715) = dp(1)*p(615) + p(1)*dp(615)
    dp(716) = dp(1)*p(616) + p(1)*dp(616)
    dp(717) = dp(1)*p(617) + p(1)*dp(617)
    dp(718) = dp(1)*p(618) + p(1)*dp(618)
    dp(719) = dp(1)*p(619) + p(1)*dp(619)
    dp(720) = dp(1)*p(620) + p(1)*dp(620)
    dp(721) = dp(1)*p(621) + p(1)*dp(621)
    dp(722) = dp(1)*p(622) + p(1)*dp(622)
    dp(723) = dp(1)*p(623) + p(1)*dp(623)
    dp(724) = dp(1)*p(624) + p(1)*dp(624)
    dp(725) = dp(1)*p(625) + p(1)*dp(625)
    dp(726) = dp(1)*p(626) + p(1)*dp(626)
    dp(727) = dp(1)*p(627) + p(1)*dp(627)
    dp(728) = dp(1)*p(628) + p(1)*dp(628)
    dp(729) = dp(1)*p(629) + p(1)*dp(629)
    dp(730) = dp(1)*p(630) + p(1)*dp(630)
    dp(731) = dp(1)*p(631) + p(1)*dp(631)
    dp(732) = dp(1)*p(632) + p(1)*dp(632)
    dp(733) = dp(1)*p(633) + p(1)*dp(633)
    dp(734) = dp(1)*p(634) + p(1)*dp(634)
    dp(735) = dp(1)*p(635) + p(1)*dp(635)
    dp(736) = dp(1)*p(636) + p(1)*dp(636)
    dp(737) = dp(1)*p(637) + p(1)*dp(637)
    dp(738) = dp(1)*p(638) + p(1)*dp(638)
    dp(739) = dp(1)*p(639) + p(1)*dp(639)
    dp(740) = dp(1)*p(640) + p(1)*dp(640)
    dp(741) = dp(1)*p(641) + p(1)*dp(641)
    dp(742) = dp(1)*p(642) + p(1)*dp(642)
    dp(743) = dp(1)*p(643) + p(1)*dp(643)
    dp(744) = dp(1)*p(644) + p(1)*dp(644)
    dp(745) = dp(1)*p(645) + p(1)*dp(645)
    dp(746) = dp(1)*p(646) + p(1)*dp(646)
    dp(747) = dp(1)*p(647) + p(1)*dp(647)
    dp(748) = dp(1)*p(648) + p(1)*dp(648)
    dp(749) = dp(1)*p(649) + p(1)*dp(649)
    dp(750) = dp(1)*p(650) + p(1)*dp(650)
    dp(751) = dp(1)*p(651) + p(1)*dp(651)
    dp(752) = dp(1)*p(652) + p(1)*dp(652)
    dp(753) = dp(1)*p(653) + p(1)*dp(653)
    dp(754) = dp(1)*p(654) + p(1)*dp(654)
    dp(755) = dp(1)*p(655) + p(1)*dp(655)
    dp(756) = dp(1)*p(656) + p(1)*dp(656)
    dp(757) = dp(1)*p(657) + p(1)*dp(657)
    dp(758) = dp(1)*p(658) + p(1)*dp(658)
    dp(759) = dp(1)*p(696) + p(1)*dp(696)
    dp(760) = dp(1)*p(659) + p(1)*dp(659)
    dp(761) = dp(1)*p(660) + p(1)*dp(660)
    dp(762) = dp(1)*p(661) + p(1)*dp(661)
    dp(763) = dp(1)*p(662) + p(1)*dp(662)
    dp(764) = dp(1)*p(663) + p(1)*dp(663)
    dp(765) = dp(1)*p(664) + p(1)*dp(664)
    dp(766) = dp(1)*p(665) + p(1)*dp(665)
    dp(767) = dp(1)*p(698) + p(1)*dp(698)
    dp(768) = dp(1)*p(666) + p(1)*dp(666)
    dp(769) = dp(1)*p(667) + p(1)*dp(667)
    dp(770) = dp(1)*p(668) + p(1)*dp(668)
    dp(771) = dp(1)*p(669) + p(1)*dp(669)
    dp(772) = dp(1)*p(670) + p(1)*dp(670)
    dp(773) = dp(1)*p(671) + p(1)*dp(671)
    dp(774) = dp(1)*p(700) + p(1)*dp(700)
    dp(775) = dp(1)*p(672) + p(1)*dp(672)
    dp(776) = dp(1)*p(673) + p(1)*dp(673)
    dp(777) = dp(1)*p(674) + p(1)*dp(674)
    dp(778) = dp(1)*p(675) + p(1)*dp(675)
    dp(779) = dp(1)*p(676) + p(1)*dp(676)
    dp(780) = dp(1)*p(702) + p(1)*dp(702)
    dp(781) = dp(1)*p(677) + p(1)*dp(677)
    dp(782) = dp(1)*p(678) + p(1)*dp(678)
    dp(783) = dp(1)*p(679) + p(1)*dp(679)
    dp(784) = dp(1)*p(680) + p(1)*dp(680)
    dp(785) = dp(1)*p(704) + p(1)*dp(704)
    dp(786) = dp(1)*p(681) + p(1)*dp(681)
    dp(787) = dp(1)*p(682) + p(1)*dp(682)
    dp(788) = dp(1)*p(683) + p(1)*dp(683)
    dp(789) = dp(1)*p(706) + p(1)*dp(706)
    dp(790) = dp(1)*p(684) + p(1)*dp(684)
    dp(791) = dp(1)*p(685) + p(1)*dp(685)
    dp(792) = dp(1)*p(708) + p(1)*dp(708)
    dp(793) = dp(1)*p(686) + p(1)*dp(686)
    dp(794) = dp(1)*p(710) + p(1)*dp(710)
    dp(795) = dp(1)*p(712) + p(1)*dp(712)
    dp(796) = dp(1)*p(687) + p(1)*dp(687)
    dp(797) = dp(1)*p(688) + p(1)*dp(688)
    dp(798) = dp(1)*p(689) + p(1)*dp(689)
    dp(799) = dp(1)*p(690) + p(1)*dp(690)
    dp(800) = dp(1)*p(691) + p(1)*dp(691)
    dp(801) = dp(1)*p(692) + p(1)*dp(692)
    dp(802) = dp(1)*p(693) + p(1)*dp(693)
    dp(803) = dp(1)*p(694) + p(1)*dp(694)
    dp(804) = dp(1)*p(695) + p(1)*dp(695)
    dp(805) = dp(1)*p(697) + p(1)*dp(697)
    dp(806) = dp(4)*p(598) + p(4)*dp(598)
    dp(807) = dp(1)*p(699) + p(1)*dp(699)
    dp(808) = dp(4)*p(600) + p(4)*dp(600)
    dp(809) = dp(1)*p(701) + p(1)*dp(701)
    dp(810) = dp(4)*p(602) + p(4)*dp(602)
    dp(811) = dp(1)*p(703) + p(1)*dp(703)
    dp(812) = dp(4)*p(604) + p(4)*dp(604)
    dp(813) = dp(1)*p(705) + p(1)*dp(705)
    dp(814) = dp(4)*p(606) + p(4)*dp(606)
    dp(815) = dp(1)*p(707) + p(1)*dp(707)
    dp(816) = dp(4)*p(608) + p(4)*dp(608)
    dp(817) = dp(1)*p(709) + p(1)*dp(709)
    dp(818) = dp(4)*p(610) + p(4)*dp(610)
    dp(819) = dp(1)*p(711) + p(1)*dp(711)
    dp(820) = dp(4)*p(612) + p(4)*dp(612)
    dp(821) = dp(1)*p(714) + p(1)*dp(714)
    dp(822) = dp(4)*p(614) + p(4)*dp(614)
    dp(823) = dp(1)*p(713) + p(1)*dp(713)
    dp(824) = dp(2)*p(714) + p(2)*dp(714) - dp(822)
    dp(825) = dp(1)*p(715) + p(1)*dp(715)
    dp(826) = dp(1)*p(716) + p(1)*dp(716)
    dp(827) = dp(1)*p(717) + p(1)*dp(717)
    dp(828) = dp(1)*p(718) + p(1)*dp(718)
    dp(829) = dp(1)*p(719) + p(1)*dp(719)
    dp(830) = dp(1)*p(720) + p(1)*dp(720)
    dp(831) = dp(1)*p(721) + p(1)*dp(721)
    dp(832) = dp(1)*p(722) + p(1)*dp(722)
    dp(833) = dp(1)*p(723) + p(1)*dp(723)
    dp(834) = dp(1)*p(724) + p(1)*dp(724)
    dp(835) = dp(1)*p(725) + p(1)*dp(725)
    dp(836) = dp(1)*p(726) + p(1)*dp(726)
    dp(837) = dp(1)*p(727) + p(1)*dp(727)
    dp(838) = dp(1)*p(728) + p(1)*dp(728)
    dp(839) = dp(1)*p(729) + p(1)*dp(729)
    dp(840) = dp(1)*p(730) + p(1)*dp(730)
    dp(841) = dp(1)*p(731) + p(1)*dp(731)
    dp(842) = dp(1)*p(732) + p(1)*dp(732)
    dp(843) = dp(1)*p(733) + p(1)*dp(733)
    dp(844) = dp(1)*p(734) + p(1)*dp(734)
    dp(845) = dp(1)*p(735) + p(1)*dp(735)
    dp(846) = dp(1)*p(736) + p(1)*dp(736)
    dp(847) = dp(1)*p(737) + p(1)*dp(737)
    dp(848) = dp(1)*p(738) + p(1)*dp(738)
    dp(849) = dp(1)*p(739) + p(1)*dp(739)
    dp(850) = dp(1)*p(740) + p(1)*dp(740)
    dp(851) = dp(1)*p(741) + p(1)*dp(741)
    dp(852) = dp(1)*p(742) + p(1)*dp(742)
    dp(853) = dp(1)*p(743) + p(1)*dp(743)
    dp(854) = dp(1)*p(744) + p(1)*dp(744)
    dp(855) = dp(1)*p(745) + p(1)*dp(745)
    dp(856) = dp(1)*p(746) + p(1)*dp(746)
    dp(857) = dp(1)*p(747) + p(1)*dp(747)
    dp(858) = dp(1)*p(748) + p(1)*dp(748)
    dp(859) = dp(1)*p(749) + p(1)*dp(749)
    dp(860) = dp(1)*p(750) + p(1)*dp(750)
    dp(861) = dp(1)*p(751) + p(1)*dp(751)
    dp(862) = dp(1)*p(752) + p(1)*dp(752)
    dp(863) = dp(1)*p(753) + p(1)*dp(753)
    dp(864) = dp(1)*p(754) + p(1)*dp(754)
    dp(865) = dp(1)*p(755) + p(1)*dp(755)
    dp(866) = dp(1)*p(756) + p(1)*dp(756)
    dp(867) = dp(1)*p(757) + p(1)*dp(757)
    dp(868) = dp(1)*p(758) + p(1)*dp(758)
    dp(869) = dp(1)*p(759) + p(1)*dp(759)
    dp(870) = dp(1)*p(760) + p(1)*dp(760)
    dp(871) = dp(1)*p(761) + p(1)*dp(761)
    dp(872) = dp(1)*p(762) + p(1)*dp(762)
    dp(873) = dp(1)*p(763) + p(1)*dp(763)
    dp(874) = dp(1)*p(764) + p(1)*dp(764)
    dp(875) = dp(1)*p(765) + p(1)*dp(765)
    dp(876) = dp(1)*p(766) + p(1)*dp(766)
    dp(877) = dp(1)*p(767) + p(1)*dp(767)
    dp(878) = dp(1)*p(806) + p(1)*dp(806)
    dp(879) = dp(1)*p(768) + p(1)*dp(768)
    dp(880) = dp(1)*p(769) + p(1)*dp(769)
    dp(881) = dp(1)*p(770) + p(1)*dp(770)
    dp(882) = dp(1)*p(771) + p(1)*dp(771)
    dp(883) = dp(1)*p(772) + p(1)*dp(772)
    dp(884) = dp(1)*p(773) + p(1)*dp(773)
    dp(885) = dp(1)*p(774) + p(1)*dp(774)
    dp(886) = dp(1)*p(808) + p(1)*dp(808)
    dp(887) = dp(1)*p(775) + p(1)*dp(775)
    dp(888) = dp(1)*p(776) + p(1)*dp(776)
    dp(889) = dp(1)*p(777) + p(1)*dp(777)
    dp(890) = dp(1)*p(778) + p(1)*dp(778)
    dp(891) = dp(1)*p(779) + p(1)*dp(779)
    dp(892) = dp(1)*p(780) + p(1)*dp(780)
    dp(893) = dp(1)*p(810) + p(1)*dp(810)
    dp(894) = dp(1)*p(781) + p(1)*dp(781)
    dp(895) = dp(1)*p(782) + p(1)*dp(782)
    dp(896) = dp(1)*p(783) + p(1)*dp(783)
    dp(897) = dp(1)*p(784) + p(1)*dp(784)
    dp(898) = dp(1)*p(785) + p(1)*dp(785)
    dp(899) = dp(1)*p(812) + p(1)*dp(812)
    dp(900) = dp(1)*p(786) + p(1)*dp(786)
    dp(901) = dp(1)*p(787) + p(1)*dp(787)
    dp(902) = dp(1)*p(788) + p(1)*dp(788)
    dp(903) = dp(1)*p(789) + p(1)*dp(789)
    dp(904) = dp(1)*p(814) + p(1)*dp(814)
    dp(905) = dp(1)*p(790) + p(1)*dp(790)
    dp(906) = dp(1)*p(791) + p(1)*dp(791)
    dp(907) = dp(1)*p(792) + p(1)*dp(792)
    dp(908) = dp(1)*p(816) + p(1)*dp(816)
    dp(909) = dp(1)*p(793) + p(1)*dp(793)
    dp(910) = dp(1)*p(794) + p(1)*dp(794)
    dp(911) = dp(1)*p(818) + p(1)*dp(818)
    dp(912) = dp(1)*p(795) + p(1)*dp(795)
    dp(913) = dp(1)*p(820) + p(1)*dp(820)
    dp(914) = dp(1)*p(822) + p(1)*dp(822)
    dp(915) = dp(1)*p(796) + p(1)*dp(796)
    dp(916) = dp(1)*p(797) + p(1)*dp(797)
    dp(917) = dp(1)*p(798) + p(1)*dp(798)
    dp(918) = dp(1)*p(799) + p(1)*dp(799)
    dp(919) = dp(1)*p(800) + p(1)*dp(800)
    dp(920) = dp(1)*p(801) + p(1)*dp(801)
    dp(921) = dp(1)*p(802) + p(1)*dp(802)
    dp(922) = dp(1)*p(803) + p(1)*dp(803)
    dp(923) = dp(1)*p(804) + p(1)*dp(804)
    dp(924) = dp(1)*p(805) + p(1)*dp(805)
    dp(925) = dp(4)*p(696) + p(4)*dp(696)
    dp(926) = dp(1)*p(807) + p(1)*dp(807)
    dp(927) = dp(4)*p(698) + p(4)*dp(698)
    dp(928) = dp(1)*p(809) + p(1)*dp(809)
    dp(929) = dp(4)*p(700) + p(4)*dp(700)
    dp(930) = dp(1)*p(811) + p(1)*dp(811)
    dp(931) = dp(4)*p(702) + p(4)*dp(702)
    dp(932) = dp(1)*p(813) + p(1)*dp(813)
    dp(933) = dp(4)*p(704) + p(4)*dp(704)
    dp(934) = dp(1)*p(815) + p(1)*dp(815)
    dp(935) = dp(4)*p(706) + p(4)*dp(706)
    dp(936) = dp(1)*p(817) + p(1)*dp(817)
    dp(937) = dp(4)*p(708) + p(4)*dp(708)
    dp(938) = dp(1)*p(819) + p(1)*dp(819)
    dp(939) = dp(4)*p(710) + p(4)*dp(710)
    dp(940) = dp(1)*p(821) + p(1)*dp(821)
    dp(941) = dp(4)*p(712) + p(4)*dp(712)
    dp(942) = dp(1)*p(824) + p(1)*dp(824)
    dp(943) = dp(4)*p(714) + p(4)*dp(714)
    dp(944) = dp(1)*p(823) + p(1)*dp(823)
    dp(945) = dp(2)*p(824) + p(2)*dp(824) - dp(943)

    return
  end subroutine devpoly

end module gradient
module pes_shell
use basis
use gradient
implicit none

  real::coeff(1:946) ! change to number of coefficients
                     ! (size of c in bemsa.f90)
  save coeff

contains
  !==================================!
  ! read the coefficients of the PES !
  !==================================!
  subroutine pes_init()
    !::::::::::::::::::
    integer::i

    open(10,file='coeff_Li2H_local.dat',status='old')

    do i=1,size(coeff)
       read (10,*) coeff(i)
    end do

    return
    close (10)
  end subroutine pes_init

  !====================================!
  ! Function to evaluate the potential !
  !====================================!
  function f(xyz)
    real,dimension(:,:),intent(in)::xyz
    real::f
    !::::::::::::::::::::::::::::::
    real,dimension(size(xyz,2)*(size(xyz,2)-1)/2)::x
    real,dimension(3)::dr
    real::a0  ! the same as the fitting code
    integer::i,j,k

    a0 = 7.500d0

    k = 1
    do i=1,size(xyz,2)-1
       do j=i+1,size(xyz,2)
          dr = xyz(:,i) - xyz(:,j)
          x(k) = sqrt(dot_product(dr,dr))
          k = k+1
       end do
    end do

    do i=1,size(x)
       x(i)=exp(-x(i)/a0)
    end do

    f=emsav(x,coeff)

    return
  end function f

  !===========================!
  ! function to calculate the !
  ! analytical gradient       !
  !===========================!
  function g(xyz)
    real,dimension(:,:),intent(in)::xyz
    real,dimension(size(xyz,2)*3)::g
    !::::::::::::::::::::
    real,dimension(size(xyz,2)*(size(xyz,2)-1)/2)::r,x
    real,dimension(3,size(xyz,2)*(size(xyz,2)-1)/2)::dr
    real,dimension(size(xyz,2)*3,size(xyz,2)*(size(xyz,2)-1)/2)::drdx
    real,dimension(1:946)::p   ! change to number of popynomials
                               ! (size of p in bemsa.f90)
    real,dimension(1:5)::m  ! change to number of monomials
                              ! (size of m in bemsa.f90
    real::a0
    integer::i,j,k

    a0 = 7.500d0

    k = 1
    drdx = 0.d0
    do i=1,size(xyz,2)-1
       do j=i+1,size(xyz,2)
          dr(:,k) = xyz(:,i) - xyz(:,j)
          r(k) = sqrt(dot_product(dr(:,k),dr(:,k)))

          drdx(3*i-2:3*i,k) = dr(:,k)/r(k)
          drdx(3*j-2:3*j,k) = -drdx(3*i-2:3*i,k)
          k = k+1
       end do
    end do

    do i=1,size(x)
       x(i)=exp(-r(i)/a0)
    end do

    call evmono(x,m)
    call evpoly(m,p)

    do i=1,3*size(xyz,2)
       g(i) = demsav(drdx,coeff,m,p,i)
    end do

    return
  end function g

end module pes_shell
